#!/usr/local/bin/perl
##############################################################################
# Hyperseek Search Engine                                                    #
# Copyright 2000 John Cokos     jcokos@ccs.net                               #
# Created 05/01/2000            Last Modified 05/16/2000                     #
# Script Home Page:            http://www.interactive-web.net                #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# The Hyperseek Search Engine, including all files in the this distribution  #
# may be modified only by registered users so long as...                     #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
#  _                           _   _                                         #
# | \ _  ._  __|_ |\/| _  _|o_|_  |_) _ | _      _|_|_ o _ ._  _ o.__|_ |    #
# |_/(_) | |(_)|_ |  |(_)(_|| |\/ |_)(/_|(_)\/\/  |_| ||_> |_)(_)|| ||_ o    #
#                              /                           |                 #
# __________________________________________________________________________ #


require ("iweb.pm");
&parse_form;



$PROGRAM="Hyperseek Search Engine (GO)";
$VERSION="6.01";


# Some Misc Info ...
$Index_File = "$data_dir/hyperseek.dat";
$JumpToID = $input{'ID'};
$FILE = "$data_dir/hits/$JumpToID.cnt";


$delimiter = '|';
open(ALLFILE,"$Index_File") || &Fatal;
foreach $LINE (<ALLFILE>)
	{
	($ID,$Category,$SubCategory,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);
        
        if($JumpToID eq $ID) {
           &GoTo($ID, $URL);
        }
        }

       
close(ALLFILE);

## If we're here, then it was not found....

print "Content-Type: text/html\n\n";
print "<H1>Error: $JumptoID Not Found in Database";

exit 0;


sub GoTo {

    $ID_NUMBER=$_[0];
    $HREF=$_[1];

    open (COUNT, "$FILE");
      @lines = <COUNT>;
    close (COUNT);

    @entries = split(/\|/,$lines[0]);

    $num_hits = $entries[0];
    $num_votes = $entries[1];
    $num_hits =~ s/\n//g;
    $num_votes =~ s/\n//g;

    $num_hits++; 

    open(COUNT, ">$FILE");
    &lock(TOT);
       print COUNT "$num_hits|$num_votes|GOTO";
    close(COUNT);
    &unlock(TOT);


    print "Location: $HREF\n\n";


exit 0;

}
