#!/usr/local/bin/perl
##############################################################################
# Hyperseek Search Engine                                                    #
# Copyright 2000 John Cokos     jcokos@ccs.net                               #
# Created 05/01/2000            Last Modified 05/16/2000                     #
# Script Home Page:            http://www.interactive-web.net                #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# The Hyperseek Search Engine, including all files in the this distribution  #
# may be modified only by registered users so long as...                     #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
#  _                           _   _                                         #
# | \ _  ._  __|_ |\/| _  _|o_|_  |_) _ | _      _|_|_ o _ ._  _ o.__|_ |    #
# |_/(_) | |(_)|_ |  |(_)(_|| |\/ |_)(/_|(_)\/\/  |_| ||_> |_)(_)|| ||_ o    #
#                              /                           |                 #
##############################################################################

   require ("iweb.pm");
   &parse_form;


$PROGRAM="Hyperseek Search Engine Admin";
$VERSION="6.01";

  #### Buttons and HTML file locations
  $help_button = $button_dir."/help.gif";
  $ccs_button = $button_dir."/ccs_bbs.gif";
  $manual = $html_dir."/hs_manual.html";

  #### File names / etc sent from html
  $engine_data = "$data_dir/hyperseek.dat";
  $engine_temp = "$data_dir/hyperseek.temp";
  $sub_data = "$data_dir/subcategories.dat";
  $cat_data = "$data_dir/categories.dat";
  
  #### Variable names and values sent from html
  $category = $input{'category'};
  $del_category = $input{'Headers'};
  $sub_category = $input{'sub_category'};
  $sub_categories = $input{'sub_categories'};
  $cat_description = $input{'cat_description'};
  $deep_subs = $input{'deep_subs'};
  $contact_name = $input{'a_name'};
  $contact_email = $input{'a_email'};
  $new_url = $input{'a_url'};
  $new_title = $input{'a_title'};
  $new_text = $input{'a_text'};
  $new_xtra = " " . $input{'a_xtra'} . " ";
  $new_weight = $input{'a_weight'};

  $moderator = $input{'moderator'};
  $moderator_pw = $input{'moderator_pw'};

  # These are for deleting messages
  $id = $input{'id'};
  $del_url = $input{'del_url'};


  #### What are we doing ???
  $action = $input{'action'};
  $password = $input{'password'};

  if( !($password || $moderator_pw) )  { &Moderator_Login; }
  else { &Validate_Admin; }

  ### If not readonly, or password is ok, do the right thing...
  if ($action eq "admin") { &hs_admin; }
 
  if ($action eq "menu")   {&nav_bar;}

  if ($action eq "Category Mgr") { &CatManager; }
    if ($action eq "Delete this category") {&delete_category;}
    if ($action eq "Edit this category") {&EditCategory;}
    if ($action eq "Refine Subcategories") {&Refine;}
    if ($action eq "save_edits") {&SaveEdits;}
    if ($action eq "New Category") {&NewCategory;}
    if ($action eq "post_cat") {&PostCategory;}

  if ($action eq "Utilities") {&DBManager;}
    if ($action eq "Qualifiers") {&Qualifiers;}
    if ($action eq "Save Qualifiers") {&Save_Qualifiers;}
    if ($action eq "Change Categories") {&ChangeCategories;}
    if ($action eq "Change Subcategories") {&ChangeSubCategories;}
    if ($action eq "Generate Mailing List From Hyperseek Database") { &CreateMailList; }
    if ($action eq "Create Forums") { &CreateForums; }
    if ($action eq "Create Classifieds") { &CreateClassifieds; }
    if ($action eq "Create HTML") { &Build_HTML; }
    if ($action eq "Create Banner Categories") { &Create_Banner_Categories; }
    if ($action eq "Email Editor") { &Edit_Email; }
    if ($action eq "Reject Editor") { &Edit_Rejection; }
    if ($action eq "Save Email") { &Save_Email; }
    if ($action eq "Save Rejection Letters") { &Save_Rejection; }
    if ($action eq "edit_file") { &Edit_File; }
    if ($action eq "Save File") { &Save_File; }

  if ($action eq "Link Mgr") { &CategoryListing; }
    if ($action eq "Delete") { &DeleteLink; }
    if ($action eq "Edit") { &EditEntry; }
    if ($action eq "Change Entry") { &ChangeLink; }
    if ($action eq "View Category") { &LinkManager; }
    if ($action eq "List All Entries") { &List_All; }

  if ($action eq "New Additions") { &NewList; }
  if ($action eq "Review") { &LinkReviewer; }
    if ($action eq "Process") { &Process_Additions; }
    if ($action eq "Add Entry") { &AddEntry; }
    if ($action eq "Delete Entry") { &DeleteEntry; }

  if ($action eq "" ) {&Moderator_Login;}




##############################################################################
# Validate Moderators / Administrators
##############################################################################
sub Validate_Admin {

   # &admin_readYH;

   $Allowed = "F";

   if ($password eq $admin_pw) { $Allowed = "T"; }
   if ($moderator_pw) { $Allowed = "T"; }

   if ($Allowed eq "F") {
	&ERROR("Access Denied.");
        exit 0;
   }


}

##############################################################################
# Category Listing For moderators...
##############################################################################
sub Moderator_Login {

   &admin_readYH;

        print "Content-Type: text/html\n\n";
        print <<DONE;

        <HTML>
        <BODY BGCOLOR="$pg_color">
        <FORM ACTION="mod_cat.cgi">
        <CENTER>
        <TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0><TR><TD>
        <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=5>
          <TR BGCOLOR="$title_color"><TD><FONT FACE="$font_face" COLOR="$ttxt_color">Moderator Login</TD></TR>
          <TR BGCOLOR="$win_color"><TD><FONT FACE="$font_face" COLOR="$text_color"><PRE>
            Moderator Name: <INPUT NAME="moderator" SIZE=15>
                 Password : <INPUT NAME="moderator_pw" SIZE=15></PRE>  
            <CENTER><INPUT TYPE="submit" NAME="action" VALUE="Login"></CENTER>

        </TD></TR></TABLE>
        </TD></TR></TABLE>

        </CENTER>
        </FORM>
DONE

        exit 0;


}

##############################################################################
# List the categories and sub categories
##############################################################################
sub CategoryListing {

   &admin_readYH;
        
        print "Content-Type: text/html\n\n";
        print "<HTML>\n";
        print "<BODY BGCOLOR=\"$pg_color\">\n";

        print "<FORM ACTION=\"hs_admin.cgi\">\n";
        print "<H3>Lookup by ID Number:</H3> \n";
        print "Full URL: <INPUT NAME=\"id\"><INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"Edit\">\n";
        print "<INPUT TYPE=\"hidden\" NAME=\"search_type\" VALUE=\"ID\">\n";
        print "<INPUT TYPE=\"hidden\" NAME=\"password\" VALUE=\"$admin_pw\">\n";
        print "<INPUT TYPE=\"submit\" VALUE=\"Edit Record\">\n";
        print "</FORM><HR>\n";

        print "<FORM ACTION=\"hs_admin.cgi\">\n";
        print "<H3>Lookup by URL:</H3> \n";
        print "Full URL: <INPUT NAME=\"url\" VALUE=\"http://\"><INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"Edit\">\n";
        print "<INPUT TYPE=\"hidden\" NAME=\"search_type\" VALUE=\"URL\">\n";
        print "<INPUT TYPE=\"hidden\" NAME=\"password\" VALUE=\"$admin_pw\">\n";
        print "<INPUT TYPE=\"submit\" VALUE=\"Edit Record\">\n";
        print "</FORM><HR>\n";

        print "<FORM ACTION=\"hs_admin.cgi\">\n";
        print "<H3>Lookup by submitters Email Address:</H3> \n";
        print "Email Address: <INPUT NAME=\"email\"><INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"Edit\">\n";
        print "<INPUT TYPE=\"hidden\" NAME=\"search_type\" VALUE=\"EMAIL\">\n";
        print "<INPUT TYPE=\"hidden\" NAME=\"password\" VALUE=\"$admin_pw\">\n";
        print "<INPUT TYPE=\"submit\" VALUE=\"Edit Record\">\n";
        print "</FORM><HR>\n";

        print "<H3>Select a Sub Category to browse entries...</H3>\n";
        print "<FORM ACTION=\"hs_admin.cgi\">\n";

        print "<BR><BR>\n";

          &SubCategorySelectList;

        print "<INPUT TYPE=\"hidden\" NAME=\"password\" VALUE=\"$admin_pw\">\n";

        print "<BR><BR><INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"View Category\">\n";

        print "</FORM><HR>\n";


        exit 0;


}



##############################################################################
# List the categories and sub categories
##############################################################################
sub List_All {


      print "Content-Type: text/html\n\n";
      print "<HTML>\n";
      print "<BODY BGCOLOR=\"$pg_color\">\n";
      print "<CENTER><H1>Link Database Manager (All Links)</H1></CENTER>\n";
      print "<BLOCKQUOTE>\n";

      open(ALLFILE,"$engine_data");
      foreach $LINE (<ALLFILE>) {
	 ($ID,$Cat,$Sub,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);


          print "<a href=\"$url\" target=\"new\">$Title</a> ... Options: ";
          print "<a href=\"hs_admin.cgi?action=Delete+This+Entry&id=$ID&search_type=ID\">Delete</a> ... ";
          print "<a href=\"hs_admin.cgi?action=Edit&id=$ID&search_type=ID\">Edit</a>.<BR>\n";
          print "&nbsp;&nbsp;&nbsp;&nbsp;(Cat: $Cat / Sub: $Sub)<BR><BR>\n";

      }

      exit 0;


}

##############################################################################
# List the categories and sub categories
##############################################################################
sub LinkManager {


   &admin_readYH;
        
   @entries = split(/\|/,$sub_category);
 
   $category = $entries[0];
   $sub_category = $entries[1];
     

   for $z(0 .. $#categories) {

       if ($categories[$z]{'Category'} eq $category) { 
          $ThisModerator = $categories[$z]{'Moderator'};
          $ThisPassword = $categories[$z]{'ModeratorPW'};
          last;
       }
   }


        print "Content-Type: text/html\n\n";
        print "<HTML>\n";
        print "<BODY BGCOLOR=\"$pg_color\">\n";
        print "<CENTER><H1>Link Database Manager</H1></CENTER>\n";
        print "<CENTER><H3>($category / $sub_category)</H3></CENTER>\n";

        print "<FORM ACTION=\"hs_admin.cgi\">\n"; 
        print "<CENTER><INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"List All Entries\">\n";
        print "<INPUT TYPE=\"hidden\" NAME=\"password\" VALUE=\"$password\"></CENTER>\n";
        print "</FORM><HR WIDTH=\"75%\">\n";

        print "<BLOCKQUOTE>\n";

        #print "<TABLE BORDER=1 WIDTH=\"90%\">\n";

            ### Do the Search.....

            open(ALLFILE,"$engine_data");
            foreach $LINE (<ALLFILE>) {
	       ($ID,$Cat,$Sub,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);

               if($Cat eq $category && $Sub eq $sub_category) {
                print "<a href=\"$url\" target=\"new\">$Title</a> ... Options: ";
                print "<a href=\"hs_admin.cgi?action=Delete+This+Entry&id=$ID&search_type=ID\">Delete</a> ... ";
                print "<a href=\"hs_admin.cgi?action=Edit&id=$ID&search_type=ID\">Edit</a>.<BR><BR>\n";

               }
            }

            close(ALLFILE);

        print "</TABLE>\n";
        print "</BODY>\n";
        print "</HTML>\n";
	
	exit 0;

}



##############################################################################
# Edit a single entry.
##############################################################################
sub EditEntry {

   &admin_readYH;
   $id = $input{'id'};
   $Search_Type = $input{'search_type'};
   $email = $input{'email'};
   $url = $input{'url'};
        
            ### Do the Search.....


            open(ALLFILE,"$engine_data");
            foreach $LINE (<ALLFILE>) {
	       ($ID,$Cat,$Sub,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);


               $Found = "F";

               if($Search_Type eq "ID" && $ID eq $id) {
                   $Found="T";
               }

               if($Search_Type eq "URL" && $URL =~ $url) {
                   $Found="T";
               }

               if($Search_Type eq "EMAIL" && $Email =~ $email) {
                   $Found="T";
               }

               if($Found eq "T") {
                   for $z(0 .. $#categories) {

                       if ($categories[$z]{'Category'} eq $Cat) { 
                          ## Check moderator ...
                          if ($moderator) {
                             if ( $moderator ne $categories[$z]{'Moderator'} ||
                                  $moderator_pw ne $categories[$z]{'ModeratorPW'} ) {

                                &ERROR("Access Denied");
                                exit 0;
                             }
                          }
                          last;
                       }
                   }



                   $Record_Shown = "T";

                   print "Content-Type: text/html\n\n";
                   print "<HTML>\n";
                   print "<BODY BGCOLOR=\"$pg_color\">\n";
                   print "<CENTER>\n";
           
                   print "<TABLE BORDER=1 WIDTH=\"90%\">\n";

 	           print "  <TR BGCOLOR=\"$title_color\"><TD><FONT FACE=\"$font_face\" COLOR=\"$ttxt_color\">\n";
                   print "     <B>Link Editor</B></TD></TR>\n";

                   print "<TR BGCOLOR=\"$win_color\"><TD>\n";
                   print "<FORM ACTION=\"hs_admin.cgi\">\n";
                   print "<A HREF=\"$URL\" TARGET=\"_new\"><STRONG>$Title</STRONG></A>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
                   print "<INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Change Entry\">\n";
                   print "<INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Delete\"><BR><BR>\n";
                   print "URL:&nbsp;&nbsp;&nbsp;<INPUT NAME=\"url\" VALUE=\"$URL\" SIZE=50><BR>\n";
                   print "Title:&nbsp;&nbsp;<INPUT NAME=\"title\" VALUE=\"$Title\" SIZE=50>\n";
                   print "<BR>Submitted By: <A HREF=\"mailto:$Email\">$Email</A>&nbsp;&nbsp;&nbsp;&nbsp;<INPUT NAME=\"email\" VALUE=\"$Email\"><BR>";
                   print "<INPUT TYPE=\"hidden\" NAME=\"id\" VALUE=\"$ID\">\n";

                   $JS="F";
                   $sub_category = $Sub;
                   &SubCategorySelectList;

                   print "Description:<BR><TEXTAREA NAME=\"description\" ROWS=3 COLS=60 WRAP=\"virtual\">$Description</TEXTAREA><BR>\n";
                   print "Desired Keys: <TEXTAREA NAME=\"keywords\" ROWS=3 COLS=60 WRAP=\"virtual\">$string</TEXTAREA><BR>\n";
                   print "Ranking: <INPUT NAME=\"rank\" SIZE=2 VALUE=\"$Crank\"><BR>\n";
                   print "&nbsp;&nbsp;&nbsp;\n";
                   print "Note:  Max Ranking is &quot;10&quot;  ... rankings higher than &quot;5&quot; will have a &quot;COOL&quot; Icon displayed next to them.<BR><BR>\n";

                   print "<INPUT TYPE=\"hidden\" NAME=\"password\" VALUE=\"$password\">\n";

                   print "</FORM>\n";
                   print "</TD></TR>\n";

                   print "</TABLE>\n";
                   print "</BODY>\n";
                   print "</HTML>\n";

                   #  last;

               }
            }

            close(ALLFILE);


        if ($Found ne "T" && $Record_Shown ne "T") { &ERROR("Record Not Found"); }
	
	exit 0;

}



##############################################################################
# Create Banner Categories for use with BannerMaster
##############################################################################
sub Create_Banner_Categories {


   &admin_readYH;

   $Overwrite = $input{'Overwrite'};

   if ($Overwrite eq "Overwrite") {
      open("GRP",">$data_dir/groups/groups.def");
   }

   else {
      open("GRP",">>$data_dir/groups/groups.def");
   }

   for $z(0 .. $#subcategories) {

       $Group_Name = "$subcategories[$z]{'Category'} $subcategories[$z]{'SubCategory'}";
       $Group_Name =~ s/ /_/g;
       $Group_Name =~ s/\:/_/g;
       print GRP "$Group_Name\n";
   }

       print GRP "new\n";
       print GRP "cool\n";

   close(GRP);



    $ok_message="<H5>Banner Categories created ....<BR><BR>Open the Bannermaster Administrator to assign accounts and activate....<BR><BR></H5>";

    if ($Overwrite eq "Append") {
       $ok_message .= "<H6><FONT COLOR=\"red\">Note: You elected to <B>Append</B> to the existing groups, there may be duplicate entries.  Make sure you check the group manager in the Bannermaster admin!</FONT></H6>";
    }
    elsif ($Overwrite eq "Overwrite") {
       $ok_message .= "<H6><FONT COLOR=\"red\">Note: You elected to <B>Overwrite</B> the existing groups, Make sure you check the group manager in the Bannermaster admin to re-add any groups that may have been deleted as a result of this action...</FONT></H6>";
    }

    ## $click="self.location.href='hs_admin.cgi?action=Utilities&password=$password'";
    $click="self.close();";

    &ok_box($ok_message,$click);
}



##############################################################################
# Create a mailing list from Hyperseek Database
##############################################################################
sub CreateMailList {



    &admin_readYH;

    for $x( 0 .. $#subcategories ) {
        $file = "$data_dir/maillists/$subcategories[$x]{'Category'} $subcategories[$x]{'SubCategory'}.mail";
        $file =~ s/ /_/g;
        $file =~ s/\:/_/g;
        unlink $file;
    }


    open(ALLFILE,"$engine_data");
    open(MAILLIST, ">$data_dir/maillists/hyperseek.mail");

       foreach $LINE (<ALLFILE>) {
	  ($ID,$Cat,$Sub,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);

            $Current = "$Cat $Sub";
            $Current =~ s/ /_/g;
            $Current =~ s/\:/_/g;
            $Current =~ s/\cM/_/g;
            $Current =~ s/\n/_/g;

            print MAILLIST "$Email\n"; 
            open(THISLIST,">>$data_dir/maillists/$Current.mail");
               print THISLIST "$Email\n"; 
            close(THISLIST);
       }

    close(MAILLIST);
    close(ALLFILE);

    $ok_message="<H5>Mailing Lists created  (One master list, and one for each category/subcategory)....<BR><BR>Open the Mail man Administrator to send email</H5>";
    # $click="self.location.href='hs_admin.cgi?action=Utilities&password=$password'";
    $click="self.close();";

    &ok_box($ok_message,$click);

    exit 0;

}


##############################################################################
# Create Forums from Hyperseek Database
##############################################################################
sub CreateForums {


   if( -e "users.cgi" || -e "forums.cgi" || -e "iforum.cgi" ) {

      &admin_readYH;

      $ok_message = "<H4>Creating Forums...</H4>";
      for $x( 0 .. $#subcategories ) {

          $subcategories[$x]{'Category'} =~ s/\//_/g;
          $subcategories[$x]{'SubCategory'} =~ s/\//_/g;

          $subcategories[$x]{'Category'} =~ s/\&/_/g;
          $subcategories[$x]{'SubCategory'} =~ s/\&/_/g;

          if($yh_forums eq "MAIN") {

             $file = "$data_dir/forums/$subcategories[$x]{'Category'}";
             $name = "$subcategories[$x]{'Category'}";

          }

          if($yh_forums eq "CATEGORY") {

             $tempFORUM = "$subcategories[$x]{'Category'}:$subcategories[$x]{'SubCategory'}";
             @forum = split(/\:/, $tempFORUM);
             if($forum[1]) {
                $file = "$data_dir/forums/$forum[0]_$forum[1]";
                $name = "$forum[0]:$forum[1]";
             }

          }

          if($yh_forums eq "ALL") {

             $file = "$data_dir/forums/$subcategories[$x]{'Category'} $subcategories[$x]{'SubCategory'}";
             $name = "$subcategories[$x]{'Category'} :: $subcategories[$x]{'SubCategory'}";

          }

          $file =~ s/ /_/g;
          $file =~ s/\:/_/g;
  
          open("CFG",">$file.cfg");
	    print CFG "|";
	    print CFG "$name|";
	    print CFG "$pg_color|";
	    print CFG "$win_color|";
	    print CFG "$font|";
	    print CFG "$font_color|";
	    print CFG "$title_color|";
	    print CFG "$ttxt_color|";
	    print CFG "N|||";
	  close(CFG);
  	
	  open (MSG,">$file.dat");
	    print MSG "\n";
	  close(MSG);
  	
	  open(IDX,">$file.idx");
	    print IDX "0\n";
	    print IDX "0\n";
	  close(IDX);

          $ok_message .= "$name Created.<BR>";
  
      }
  
      $ok_message .= "<H5>Forums created ....<BR><BR>Open the BBS Administrator to access any postings in them</H5>";
      $click="self.close();";

      &ok_box($ok_message,$click);

   }

   else {
      $ok_message  = "<H5>You do not have the Hyperseek! Forums Plugin.</H5>";
      $ok_message .= "You can purchase it at <a href=\"http://www.hyperseek.com/order.html\">Our Online Order Center</A><BR><BR>";
      $ok_message .= "<H4>Thank You.</H4>\n";
   
      $click="self.close();";
   
      &ok_box($ok_message,$click);
   }

    exit 0;
}


##############################################################################
# Create Classifieds Categories 
##############################################################################
sub CreateClassifieds {


   if( -e "classifieds.cgi" ) {

      &admin_readYH;
   
      open("CLS",">$data_dir/classifieds/classifieds.dat");
         for $z(0 .. $#subcategories) {
   
             $Group_Name = "$subcategories[$z]{'Category'}::$subcategories[$z]{'SubCategory'}";
             print CLS "$z|$Group_Name\n";
         }
   
      close(GRP);
   
      $ok_message="<H5>Classified Ad Categories created ....<BR><BR></H5>";
   
      $click="self.close();";
   
      &ok_box($ok_message,$click);
   }

   else {
      $ok_message  = "<H5>You do not have the Hyperseek! Classifieds Plugin.</H5>";
      $ok_message .= "You can purchase it at <a href=\"http://www.hyperseek.com/order.html\">Our Online Order Center</A><BR><BR>";
      $ok_message .= "<H4>Thank You.</H4>\n";
   
      $click="self.close();";
   
      &ok_box($ok_message,$click);
   }

}


##############################################################################
# Delete an entry from the Main database
##############################################################################
sub DeleteLink {

   &admin_readYH;


    @entries = split(/\|/,$sub_category);
 
    $category = $entries[0];
    $sub_category = $entries[1];

    open(NEWDATA,">$engine_data.bak");

    open(ALLFILE,"$engine_data");

       foreach $LINE (<ALLFILE>) {
	  ($ID,$Cat,$Sub,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);

           if($ID ne $id) {
              print NEWDATA "$LINE"; 
           }

           else {

              ## Check moderator ...
              if ($moderator) {
                 for $z(0 .. $#categories) {
                    if ($categories[$z]{'Category'} eq $Cat) { 
                      if ( $moderator ne $categories[$z]{'Moderator'} ||
                           $moderator_pw ne $categories[$z]{'ModeratorPW'} ) {

                           print NEWDATA "$LINE"; 
                           $Denied = "T";
                      }
                    }
                 }
              }

           }
       }

    close(ALLFILE);
    close(NEWDATA);

    lock(ALLFILE);
     rename "$engine_data.bak",$engine_data;
    unlock(ALLFILE);


    $ok_message="Link Deleted ....";
    $click="self.close();";


    if ($Denied eq "T") { &ERROR("Access Denied ... Link Not Deleted"); }
    else { &ok_box($ok_message,$click); }

    exit 0;

}


##############################################################################
# Modify an entry within the Main database
##############################################################################
sub ChangeLink {

   &admin_readYH;


    @entries = split(/\|/,$sub_category);
 
    $category = $entries[0];
    $sub_category = $entries[1];

    open(NEWDATA,">$engine_data.bak");

    open(ALLFILE,"$engine_data");

       foreach $LINE (<ALLFILE>) {
	  ($ID,$Cat,$Sub,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);

           if($ID ne $id) {
                  print NEWDATA "$LINE"; 
           }
           else {
	       print NEWDATA "$id|";
	       print NEWDATA "$category|";
               print NEWDATA "$sub_category|";
               print NEWDATA "$input{'rank'}|";
               print NEWDATA "$input{'name'}|";
               print NEWDATA "$input{'email'}|";
               print NEWDATA "$input{'title'}|";
               print NEWDATA "$input{'url'}|";

               $input{'description'} =~ s/\cM/<BR>/g;
               $input{'description'} =~ s/\n//g;
               $input{'keywords'} =~ s/\n//g;
               $input{'keywords'} =~ s/\cM//g;

               print NEWDATA "$input{'description'}|";
               print NEWDATA " $input{'keywords'} |";
               print NEWDATA " $input{'filler1'} |";
               print NEWDATA " $input{'filler2'} |";
               print NEWDATA " $input{'filler3'} |";
               print NEWDATA " $input{'filler4'} |";
               print NEWDATA "\n";

           }
       }

    close(ALLFILE);
    close(NEWDATA);

    lock($engine_data);
     rename "$engine_data.bak",$engine_data;
    unlock($engine_data);

    $ok_message="Link Updated ($category / $sub_category)....";
    $click="self.close();";

    &ok_box($ok_message,$click);

    exit 0;

}


##############################################################################
# Read the text files and get the HTML sent to server with all messages      #
##############################################################################
sub NewList {

   $Start = $input{'start'};
   if( ! $Start ) { $Start = 0 };

   &admin_readYH;
        
        print "Content-Type: text/html\n\n";
        print "<HTML>\n";
        print "<SCRIPT LANGUAGE=\"javascript\">\n";
        print "   function ViewURL(c_url) {\n";
        print "      Z=window.open(c_url,\"Z\",\"toolbar=no,scrollbars=yes,directories=no,status=yes,resizable=yes,menubar=no,width=625,height=460\")\n";
        print "   }\n";
        print "</SCRIPT>\n";
        print "<BODY BGCOLOR=\"$pg_color\">\n";
        print "<CENTER><H1>Link Reviewer</H1></CENTER>\n";

        print "<h4>Below is a listing of all the new additions. Simply click on the sitename to open its \n";
        print "database record. In a separate window, the site itself will be opened so you can then review \n";
        print "it and either Add it to your Database or Delete it.</h4>\n";
        print "<h4>(Note: After you finish with the link, you'll be returned here, you will need to reload\n";
        print "this page if you want to refresh the list)\n";
        print "<BLOCKQUOTE>\n";
        print "Add / Del<BR>\n";
        print "<FORM ACTION=\"hs_admin.cgi\" METHOD=\"POST\">\n";
            open(ALLFILE,"$engine_temp");
               @TEMP=<ALLFILE>;
            close(ALLFILE);

	    for $x (0 .. $#TEMP) {
              @{$records[$count++]}{qw(id Cat Sub Crank Qualifier Email Title URL Description string filler1 filler2 filler3 filler4)} = split(/\|/,$TEMP[$x],10);
            }

            @links = sort { $a->{'URL'} cmp $b->{'URL'} } @records;

	    for $x (0 .. $#links) {

                if ( $x >= $Start && $y <= $yh_max_new ) {

                    $URL = $links[$x]{'URL'};
                    $TIME = $links[$x]{'id'};

                    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($TIME);
                    $MONTH = (January,Februrary,March,April,May,June,July,August,September,October,November,December)[(localtime($TIME))[4]];
                    $Date = "$MONTH $mday, 19$year";

                    &CheckForDups($URL);
                    print "<INPUT TYPE=\"checkbox\" NAME=\"add\" VALUE=\"$links[$x]{'id'}\">\n";
                    print "<INPUT TYPE=\"checkbox\" NAME=\"delete\" VALUE=\"$links[$x]{'id'}\">\n";
                    print "<a href=\"hs_admin.cgi?action=Review&password=$password&review=$links[$x]{'id'}\" onClick=\"ViewURL('$URL');\">\n";
                    print "$links[$x]{'Title'}</A>\n";
                    if ($DUPS >= 1) {
                        print " [ <FONT COLOR=\"red\">$DUPS Duplicates in DB</FONT> ]\n";
                    }

                    print "<BR>$URL ($Date)<BR><BR>\n";
                    $y++;
                }
            }


        print "<INPUT TYPE=\"hidden\" NAME=\"password\" VALUE=\"$password\">\n";
        print "</BLOCKQUOTE>\n";

        print "Acceptance Letter: <SELECT NAME=\"accept_letter\" onChange=\"if (this.form.accept_letter.selectedIndex >= 2) {self.location.href='#custom';}\">\n";
        print "  <OPTION VALUE=\"default\">Use Default\n";
        print "  <OPTION VALUE=\"NONE\">Do Not Send One...\n";
        print "  <OPTION VALUE=\"Custom\">Custom Email\n";
        print "  <OPTION VALUE=\"Append\">Append To Default Mail\n";
        print "</SELECT></TD>\n";
        print "<TD>\n";
        print "Rejection Letter: <SELECT NAME=\"reject_letter\" onChange=\"if (this.form.reject_letter.selectedIndex==4) {self.location.href='#custom';}\">\n";
        print "  <OPTION VALUE=\"NONE\">Do Not Send One...\n";
        print "  <OPTION VALUE=\"reject1\">$reject1\n";
        print "  <OPTION VALUE=\"reject2\">$reject2\n";
        print "  <OPTION VALUE=\"reject3\">$reject3\n";
        print "  <OPTION VALUE=\"Custom\">Custom\n";
        print "</SELECT>\n";

        print "<A NAME=\"custom\"></CENTER><BR>Custom Email: <BR><CENTER><TEXTAREA NAME=\"Custom\" ROWS=15 COLS=70></TEXTAREA>\n";
        print "<BR><BR><INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Process\">\n";

        print "</FORM>\n";

        $NewStart = $Start + $yh_max_new;
        print "<CENTER><A HREF=\"hs_admin.cgi?action=New+Additions&start=$NewStart&password=$password\">Next $yh_max_new Listings</A>\n";
        print "</BODY>\n";
        print "</HTML>\n";
	
	exit 0;

}



sub CheckForDups {

   local($CheckURL) = @_[0];
   $CheckURL =~ s/http\:\/\///g;
   @Find = split(/\./, $CheckURL);
   $CheckURL = "$Find[0] $Find[1] $Find[2]";

        $DUPS=0;
        open(DUP,"$engine_data");
            foreach $RECORD (<DUP>) {
               ($d_id,$d_Cat,$d_Sub,$d_Crank,$d_Qualifier,$d_Email,$d_Title,$d_URL,$d_Description,$d_string,$f1,$f2,$f3,$f4) = split(/\|/,$RECORD);

                $d_URL =~ s/http\:\/\///g;
                @Match = split(/\./, $d_URL);
                $Match[2] = substr($Match[2],0,3);
                $d_URL = "$Match[0] $Match[1] $Match[2]";
                if ($CheckURL =~ $d_URL) { $DUPS++; }
            } 
        close(DUP);
}

sub Process_Additions {


   $add = $input{'add'};
   $delete = $input{'delete'};

   $LOCAL="True";

   @ADD_US = split(/ /,$add);
   @DELETE_US = split(/ /,$delete);

   print "Content-Type: text/html\n\n";
   

   print "<U>ADDING...</U><BR>\n";
   print "<BLOCKQUOTE>\n";
   for $a( 0 .. $#ADD_US ) {
      $id = $ADD_US[$a];
      print "$id .... \n";
      &AddEntry
   }
   print "</BLOCKQUOTE>\n";

   print "<U>DELETING...</U><BR>\n";
   print "<BLOCKQUOTE>\n";
   for $d( 0 .. $#DELETE_US ) {
      $id = $DELETE_US[$d];
      print "$id .... \n";
      &DeleteEntry
   }
   print "</BLOCKQUOTE>\n";


   print "Done.";
   exit 0;

}

##############################################################################
# Read the text files and get the HTML sent to server with all messages      #
##############################################################################
sub LinkReviewer {



   &admin_readYH;

   $ReviewID = $input{'review'};
        
        print "Content-Type: text/html\n\n";
        print "<HTML>\n";
        print "<SCRIPT LANGUAGE=\"javascript\">\n";
        print "   function OpenZ() {\n";
        print "      S=window.open(\"\",\"S\",\"toolbar=no,scrollbars=yes,directories=no,status=yes,resizable=yes,menubar=no,width=625,height=460\")\n";
        print "   }\n";
        print "</SCRIPT>\n";
        print "<BODY BGCOLOR=\"$pg_color\">\n";
        print "<CENTER>\n";

        print "<TABLE BORDER=1 WIDTH=\"90%\">\n";

 	    print "  <TR BGCOLOR=\"$title_color\"><TD><FONT FACE=\"$font_face\" COLOR=\"$ttxt_color\">\n";
            print "     <B>Link Reviewer</B></TD></TR>\n";
 	    print "  <TR><TD><FONT FACE=\"$font_face\" COLOR=\"$text_color\">\n";
	    print "  <H4><U>$entries[0]</U></H4></TD></TR>\n";

 
            ### Do the Search.....

            open(ALLFILE,"$engine_temp");
            foreach $LINE (<ALLFILE>) {
	       ($id,$Cat,$Sub,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);


               if($id eq $ReviewID) {
                   print "<TR BGCOLOR=\"$win_color\"><TD>\n";
                   print "<FORM ACTION=\"hs_admin.cgi\">\n";

                   print "<CENTER><TABLE BORDER=0 WIDTH=\"100%\">\n";
                   print "<TR><TD><CENTER><INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Add Entry\"></TD>\n";
                   print "<TD><CENTER><INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Delete Entry\"></TD></TR>\n";

                       open(RT,"$data_dir/reject_mail.titles");
                          @titles = <RT>;
                       close(RT);
                     
                       $reject1 = $titles[0];  
                       $reject2 = $titles[1];  
                       $reject3 = $titles[2];  
                     
                       $reject1 =~ s/\n//g;
                       $reject2 =~ s/\n//g;
                       $reject3 =~ s/\n//g;
                     
                       $reject1 =~ s/\cM//g;
                       $reject2 =~ s/\cM//g;
                       $reject3 =~ s/\cM//g;
                   
                   print "<TR><TD>\n";
                   print "Acceptance Letter: <SELECT NAME=\"accept_letter\" onChange=\"if (this.form.accept_letter.selectedIndex >= 2) {self.location.href='#custom';}\">\n";
                   print "  <OPTION VALUE=\"default\">Use Default\n";
                   print "  <OPTION VALUE=\"NONE\">Do Not Send One...\n";
                   print "  <OPTION VALUE=\"Custom\">Custom Email\n";
                   print "  <OPTION VALUE=\"Append\">Append To Default Mail\n";
                   print "</SELECT></TD>\n";
                   print "<TD>\n";
                   print "Rejection Letter: <SELECT NAME=\"reject_letter\" onChange=\"if (this.form.reject_letter.selectedIndex==4) {self.location.href='#custom';}\">\n";
                   print "  <OPTION VALUE=\"NONE\">Do Not Send One...\n";
                   print "  <OPTION VALUE=\"reject1\">$reject1\n";
                   print "  <OPTION VALUE=\"reject2\">$reject2\n";
                   print "  <OPTION VALUE=\"reject3\">$reject3\n";
                   print "  <OPTION VALUE=\"Custom\">Custom\n";
                   print "</SELECT></TD></TR></TABLE><HR WIDTH=\"90%\"></CENTER>\n";

                   print "Title: <INPUT NAME=\"title\" VALUE=\"$Title\" SIZE=40><BR>\n";
                   print "<A HREF=\"$URL\" TARGET=\"_new\"><STRONG>URL</STRONG></A>";
                   print ": <INPUT NAME=\"url\" VALUE=\"$URL\" SIZE=40><BR><BR>\n";
                   print "<INPUT TYPE=\"hidden\" NAME=\"id\" VALUE=\"$id\">\n";
          
                   $category = $Cat;
                   $sub_category = "$Sub";
                   $JS="F";

                   &SubCategorySelectList;

                   if ($yh_qualify eq "Yes") {
                       print "Qualifier: \n";
                       &ListQualifiers;
                       print "<BR>\n";
                   }

                   print "<BR>Description:<BR><TEXTAREA NAME=\"description\" ROWS=3 COLS=60 WRAP=\"VIRTUAL\">$Description</TEXTAREA><BR>\n";
                   print "<BR>Desired Keys:<BR><TEXTAREA NAME=\"keywords\" ROWS=3 COLS=60 WRAP=\"VIRTUAL\">$string</TEXTAREA><BR>\n";
                   print "Ranking (No more than 10 !!!)... <INPUT NAME=\"rank\" SIZE=2 VALUE=\"$Crank\"><BR>\n";

                   print "<INPUT TYPE=\"hidden\" NAME=\"password\" VALUE=\"$password\">\n";
                   print "<BR><A HREF=\"mailto:$Email\">Submitted By:</A>";
                   print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
                   print "<INPUT NAME=\"email\" VALUE=\"$Email\" SIZE=40><BR>\n";
                   print "<CENTER><B><A HREF=\"asearch.cgi?Range=Any&Format=Standard&Terms=url:$URL&password=$password\" TARGET=\"S\" onClick=\"OpenZ();\">Is this site already Listed</A> ???\n";

                   print "<A NAME=\"custom\"></CENTER><BR>Custom Email: <BR><CENTER><TEXTAREA NAME=\"Custom\" ROWS=15 COLS=70></TEXTAREA>\n";
                   print "</FORM>\n";
                   print "</TD></TR>\n";
               }
            }

            close(ALLFILE);


        print "</TABLE>\n";
        print "</BODY>\n";
        print "</HTML>\n";
	
	exit 0;

}



##############################################################################
# Delete an entry from the temp database into the real one...
##############################################################################
sub DeleteEntry {
 
    $Rejection_Letter = $input{'reject_letter'};
    $Custom_Reply = $input{'Custom'};


    open(NEWTEMP,">$engine_temp.bak");

    open(ALLFILE,"$engine_temp");

       foreach $LINE (<ALLFILE>) {
	  ($TmpID,$Cat,$Sub,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);

           if($TmpID != $id) {
                  print NEWTEMP "$LINE"; 
           }

           else { 

                ## Send the rejection letter, if desired ##
                if ($Rejection_Letter ne "NONE" && $mail_cmd ne "NONE" && $mail_cmd ne "YOUR.IP.NUMBER.HERE") {
            
                     $Subject = "Your link was not added to our search engine";
            
                     if($Rejection_Letter eq "Custom") { $body = $Custom_Reply; }
                     else {
  
                        open ("MAIL", "$data_dir/$Rejection_Letter.send");
                           @lines=<MAIL>;
                        close(MAIL);
            
                        $body = "";
                        for $m (0 .. $#lines) {
                            $lines[$m] =~ s/\n//g;
                            $lines[$m] =~ s/\cM//g;
                            $body .= "$lines[$m]\n";
                        }
                     }

                     &SendMail($Email,$Subject,$email,$mail_cmd,$body);
                     $ok_message .= "The link was deleted from the temporary database</CENTER><BR><BR>Rejection Letter was sent to $Email<CENTER>";

                     if($LOCAL eq "True") { print "Rejection Letter Sent ... "; }
	        }
           }

       }

    close(ALLFILE);
    close(NEWTEMP);

    rename "$engine_temp.bak",$engine_temp;

    if ($LOCAL ne "True") {
        $click="history.go(-2)";
        &ok_box($ok_message,$click);
        exit 0;
    }
    else {
        print "<BR>"; 
    }


}


##############################################################################
# Add an entry from the temp database into the real one...
##############################################################################
sub AddEntry {

    $Custom_Reply = $input{'Custom'};
    $Accept_Letter = $input{'accept_letter'};

    if ($LOCAL ne "True") {
        &admin_readYH;
    }


    @entries = split(/\|/,$sub_category);
 
    $category = $entries[0];
    $sub_category = $entries[1];

    $new_mail = $input{'email'};
    $new_url = $input{'url'};
    $new_title = $input{'title'};
    $rank = $input{'rank'};
    $description = $input{'description'};
    $keywords = $input{'keywords'};
    $ReqQualifier = $input{'Qualifier'};

    open(NEWTEMP,">$engine_temp.bak");

    open(ALLFILE,"$engine_temp");

       $Found = "F";
       foreach $LINE (<ALLFILE>) {
	  ($TmpID,$Cat,$Sub,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);

           if($TmpID == $id && $Found ne "T") {
              $Found = "T";

              if ($LOCAL eq "True") {
                 $category = $Cat;
                 $sub_category = $Sub;
                 $rank = $Crank;
                 $Qualifier = $Qualifier;
                 $new_mail = $Email;
                 $new_title = $Title;
                 $new_url = $URL;
                 $description = $Description;
                 $keywords = $string;
              }

              open(DB,">>$engine_data");
                lock(DB);
	           print DB "$TmpID|";
	           print DB "$category|";
                   print DB "$sub_category|";
                   print DB "$rank|";
                   print DB "$ReqQualifier|";
                   print DB "$new_mail|";
                   print DB "$new_title|";
                   print DB "$new_url|";
                   print DB "$description|";
                   print DB " $keywords|";
                   print DB " $filler1|";
                   print DB " $filler2|";
                   print DB " $filler3|";
                   print DB " $filler4|";
          	   print DB "\n";
                unlock(DB);
              close(DB);


              if($LOCAL eq "True") { print "Link Added ... "; }


              ### Send the Thank You Email...
              if ($Accept_Letter ne "NONE" && $mail_cmd ne "NONE" && $mail_cmd ne "YOUR.IP.NUMBER.HERE") {
	        if ($Email =~ "@") {

                     $Subject = "Your link has been added";

                     if($Accept_Letter eq "Custom") { $body = $Custom_Reply; }
                     else {
                        open ("MAIL", "$data_dir/hyperseek.send");
                           @lines=<MAIL>;
                        close(MAIL);

                        $body = "";
                        for $m (0 .. $#lines) {
                           $lines[$m] =~ s/\[CATEGORY\]/$category/g;
                           $lines[$m] =~ s/\[SUBCATEGORY\]/$sub_category/g;
                           $lines[$m] =~ s/\[TITLE\]/$new_title/g;
                           $lines[$m] =~ s/\[URL\]/$new_url/g;
                           $lines[$m] =~ s/\[DESCRIPTION\]/$description/g;
                           $lines[$m] =~ s/\[KEYWORDS\]/$keywords/g;
                           $lines[$m] =~ s/\[ID\]/$TmpID/g;
                           $body .= "$lines[$m]\n";
                        }
                        if($Accept_Letter eq "Append") { $body .= "\n$Custom_Reply"; }
                     }

                  &SendMail($new_mail,$Subject,$email,$mail_cmd,$body);
                  $ok_message .= "The link was added to the main database / Mail sent to $new_mail";

                  if($LOCAL eq "True") { print "Email Sent ($new_mail) ... "; }
                }
	      }

           }
           else {
              print NEWTEMP "$LINE"; 
           }
       }

    close(ALLFILE);
    close(NEWTEMP);

    lock($engine_temp);
     rename "$engine_temp.bak",$engine_temp;
    unlock($engine_temp);


    if ($LOCAL ne "True") {
        $click="history.go(-2)";
        &ok_box($ok_message,$click);
        exit 0;
    }
    else {
        print "<BR>"; 
    }

}


##############################################################################
# Read the text files and get the HTML sent to server with all messages      #
##############################################################################
sub CatManager {



        &admin_readYH;

	$ArraySize = $#categories + 1;

	print "Content-type: text/html\n\n";
  	print "<HTML>\n";
 	print "<HEAD>\n";
 	print "  <TITLE>Message Board</TITLE>\n";
 	print "</HEAD>\n";



	print "<SCRIPT LANGUAGE=\"javascript\">\n\n";

	### Initialize some globals

	print "var CurrentMsg=\"      \";\n";
	print "var ReplyTo=\"\";\n";
	print "var CurrentThread=0;\n";
	print "var ParentThread=0;\n";

        print "     function makearray(n) {\n";
        print "         this.length = n;\n";
        print "         for(var i = 1; i <= n; i++)\n";
        print "             this[i] = 0;\n";
        print "         return this;\n";
        print "     }\n";

        ### Open the New Category
	print "function DrawWindow() {\n";
  	print '   wMessageWindow=window.open("","wMessageWindow","toolbar=no,scrollbars=yes,directories=no,resizable=yes,menubar=no,width=535,height=320");';
  	print "}\n\n";


	print "function GetSelectedIndex() {\n";
	print "    var sm= document.msg_form.Headers.selectedIndex\n";
	print "    return sm;\n";
	print "}\n\n";

	##############################################################################
	### When the user changes headers, show the correct message and update the variables.
	### Cursor at the bottom of the new message...
	##############################################################################

	print "function ShowText() {\n";
	print "   var selected_msg=GetSelectedIndex();\n";

	print "   CurrentCategory = v_category[selected_msg];\n";
	print "   SubCategory = v_sub_category[selected_msg];\n";
	print "   DeepSub = v_deep_subs[selected_msg];\n";
	print "   Desc = v_cat_description[selected_msg];\n";
	print "   Mod = v_moderator[selected_msg];\n";
	print "   Mod_pw = v_moderator_pw[selected_msg];\n";

	print "   document.msg_form.category.value = CurrentCategory;\n";
	print "   document.msg_form.sub_categories.value = \"\";\n";
	print "   document.msg_form.sub_categories.value = SubCategory;\n";
	print "   document.msg_form.deep_subs.value = \"\";\n";
	print "   document.msg_form.deep_subs.value = DeepSub;\n";
	print "   document.msg_form.cat_description.value = \"\";\n";
	print "   document.msg_form.cat_description.value = Desc;\n";
	print "   document.msg_form.moderator.value = \"\";\n";
	print "   document.msg_form.moderator.value = Mod;\n";
	print "   document.msg_form.moderator_pw.value = \"\";\n";
	print "   document.msg_form.moderator_pw.value = Mod_pw;\n";
	print "}\n\n";

	### Print JS Array Creation Function
	&ccs_js_array;

 	print "  var v_category = new MakeArray($ArraySize);\n";
	print "  var v_sub_category = new MakeArray($ArraySize);\n";
	print "  var v_deep_subs = new MakeArray($ArraySize);\n";
	print "  var v_cat_description = new MakeArray($ArraySize);\n";
	print "  var v_moderator = new MakeArray($ArraySize);\n";
	print "  var v_moderator_pw = new MakeArray($ArraySize);\n";


	$x = 0;
        $LastCategory="";
        $N = "\\r\\n";
        for $i (0 .. $#categories ) {

           $ThisCategory = $categories[$i]{'Category'};
           if ($ThisCategory ne $LastCategory) { 
 
               $LastCategory = $ThisCategory ; 

		print "  v_category[$x] = '$categories[$i]{'Category'}';\n";

		print "  v_moderator[$x] = '$categories[$i]{'Moderator'}';\n";
		print "  v_moderator_pw[$x] = '$categories[$i]{'ModeratorPW'}';\n";

                $categories[$i]{'Description'} =~ s/<BR>/$N/g;
		print "  v_cat_description[$x] = '$categories[$i]{'Description'}';\n";

                $sub = "";
                for $x (0 .. $#categories) {
                   if ($categories[$x]{'Category'} eq $categories[$i]{'Category'}) {
                      if ($sub ne "") { $sub = $sub."\\r\\n"; }
                      $sub = $sub.$categories[$x]{'SubCategory'};
                   }
                }

                print "  v_sub_category[$x] = \"$sub\";\n";

                $deep = "";
	        for $z (0 .. $#subcategories ) {
                    if ($subcategories[$z]{'Category'} eq $categories[$i]{'Category'}) {
                        if ($deep ne "") { $deep = $deep."\\r\\n"; }
                        $deep .= $subcategories[$z]{'SubCategory'};
                    }

	        }
                print "  v_deep_subs[$x] = \"$deep\";\n";

		$x ++;
           }
	}




	print "</SCRIPT>\n\n";

##############################################################################
### This is the main message list window
##############################################################################

	print "<BODY BGCOLOR=\"$pg_color\" LINK=\"#003366\" VLINK=\"#003366\" ALINK=\"#800000\" topmargin=\"10\" leftmargin=\"10\">\n";

        print "<CENTER><P><P>\n";
	print "<FORM NAME=\"msg_form\" METHOD=\"post\" ENCTYPE=\"x-www-form-urlencoded\" ACTION=\"hs_admin.cgi\">\n";
	print "<TABLE BORDER=\"2\" CELLSPACING=\"0\" CELLPADDING=\"0\">\n";

	print " <TR BGCOLOR=\"$pg_color\">\n";
	print "  <TD ALIGN=\"LEFT\" BGCOLOR=\"$pg_color\">\n";
	print "    <CENTER>\n";
	print "    <TABLE BORDER=\"0\" CELLSPACING=\"0\" CELLPADDING=\"0\" BGCOLOR=\"$win_color\">\n";
	print "       <TR BORDER=\"2\ BGCOLOR=\"$title_color\">\n";
	print "         <TD BORDER=\"0\" BGCOLOR=\"$title_color\" COLSPAN=2>\n";


	print "           <FONT FACE=\"$font_face\" COLOR=\"$ttxt_color\">\n";
	print "           Hyperseek! Category Manager\n";


	print "         </TD></TR>\n";

	print "         <TR BORDER=\"2\" BGCOLOR=\"$win_color\">\n";
	print "           <TD BORDER=\"0\" HEIGHT=\"76\">\n";

        
	print "            <P>Categories...<BR><SELECT NAME=\"Headers\" MULTIPLE SIZE=\"7\" onChange=\"ShowText(this)\;\">\n";

	$y = 0;
        $LastCategory="";
        for $x (0 .. $#categories ) {

           $ThisCategory = $categories[$x]{'Category'};
           if ($ThisCategory ne $LastCategory) { 
 
               $LastCategory = $ThisCategory ; 

	       $msg_number=$y;
               print "<OPTION VALUE=\"$msg_number\">$ThisCategory\n"; 
               $y++
            }
        }

	print "           </SELECT></TD>\n";
	print "           <TD BORDER=\"0\" HEIGHT=\"76\">\n";
	print "             <P>Main Subcategories...<BR><TEXTAREA NAME=\"sub_categories\" ROWS=5 COLS=20></TEXTAREA><P>\n";
	print "           </TD>\n";

	print "           </TR>\n";

        print "<INPUT TYPE=\"hidden\" NAME=\"cat_description\" VALUE=\"\">\n";

	print "         <TR BORDER=\"0\" BGCOLOR=\"$win_color\">\n";
	print "            <TD BORDER=\"0\" COLSPAN=2>\n";
	print "             <BR>Deeper Subcategories...<BR><TEXTAREA NAME=\"deep_subs\" ROWS=7 COLS=50></TEXTAREA><P>\n";

        print "         </TD></TR>\n";
	print "         <TR BORDER=\"0\" BGCOLOR=\"$win_color\">\n";
	print "            <TD BORDER=\"0\" COLSPAN=2>\n";




	print "               <INPUT TYPE=\'hidden\' NAME=\'category\' VALUE=\'\'>\n";
	print "               <INPUT TYPE=\'hidden\' NAME=\'moderator\' VALUE=\'\'>\n";
	print "               <INPUT TYPE=\'hidden\' NAME=\'moderator_pw\' VALUE=\'\'>\n";
	print "               <INPUT TYPE=\'hidden\' NAME=\'mode\' VALUE=\'admin\'>\n";

	print "     <BR><CENTER>\n";

        print "<INPUT TYPE=\"hidden\" NAME=\"password\" VALUE=\"$password\">\n";
        print "     <INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Delete this category\">&nbsp;&nbsp;&nbsp;\n";
	print "     <INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Edit this category\"><BR><BR>\n";
	print "     <CEnTER><INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"New Category\"><BR>\n";

	print "    </TD>\n";
	print "  </TR>\n";
	print "</TABLE>\n";

	print "		</TD>\n";
	print "	  </TR>\n";
	print "	</TABLE></FORM></CENTER>\n";



    print "<BR><BR>\n";

    print "<CENTER>\n";
    print "<HR>\n";
    print "<FONT SIZE=1>Copyright &copy; 2000 <A HREF=\"http://www.ccs.net\">The CCS Network</A></CENTER>\n";

	print "</BODY>\n";
	

	print "</HTML>\n";
	
	exit 0;

}






###########################################################################
#                 ___         __              _
#                /   |   ____/ / ____ ___    (_) ____
#               / /| |  / __  / / __ `__ \  / / / __ \
#              / ___ | / /_/ / / / / / / / / / / / / / _   _   _
#             /_/  |_| \__,_/ /_/ /_/ /_/ /_/ /_/ /_/ (_) (_) (_)
#
###########################################################################



###########################################################################
###########################################################################
sub hs_admin {



   ### Password Must be OK, Open Frames...

	print "Content-type: text/html\n\n";
	print "<HTML>\n";
	print "<HEAD>\n";
  	print "<TITLE>Hyperseek Administration</TITLE>\n";
	print "</HEAD>\n";

	print "<frameset rows=\"10%,*\" framespacing=0>\n";
    	print "<!-- Top Frame:  Shows Welcome Message and a list of available forums -->\n";
	print "<frame name=\"top\" src=\"hs_admin.cgi?action=menu&password=$password\" border=\"1\" scrolling=\"no\" marginheight=0>\n";
  
    	print "<!-- Main frame, starts with home page, used for all internal links -->\n";
    	print "<frame name=\"main\" src=\"ahyperseek.cgi?password=$password\"  border=\"1\" marginheight=0>\n";
	print "</frameset\n";

	print "</FORM>\n";
	print "<CENTER>\n";
	print "</BODY>\n";
	print "</HTML>\n";




	exit 0;
}


###########################################################################
###########################################################################
## Menu Frame...

sub nav_bar {

        print "Content-Type: text/html\n\n";

        open ("NEW","$data_dir/hyperseek.temp");
          @new = <NEW>;
        close(NEW);

        $NEW = $#new + 1;
        if ($NEW < 0) { $NEW=0; }

        print <<DONE;

    <SCRIPT LANGUAGE="javascript">
        function OpenWindow(form) {
           X=window.open("","X","toolbar=no,scrollbars=yes,status=yes,directories=no,resizable=yes,menubar=no,width=625,height=460")
        }

        function OpenUtilityWindow(form) {
           i = form.select_utilities.selectedIndex;
           if ( i == 1) { top.location.href="admin.cgi?action=admin&password=$password";return; }
           if ( i == 2 ) { Loc = "hs_admin.cgi?action=Category+Mgr&password=$password"; }
           if ( i == 3 ) { Loc = "hs_admin.cgi?action=Generate+Mailing+List+From+Hyperseek+Database&password=$password"; } 
           if ( i == 4 ) { Loc = "hs_admin.cgi?action=Email+Editor&password=$password"; } 
           if ( i == 5 ) { Loc = "hs_admin.cgi?action=Reject+Editor&password=$password"; } 
           if ( i == 6 ) { Loc = "nph-validate.cgi?password=$password"; } 
           if ( i == 7 ) { Loc = "nph-build.cgi?password=$password"; } 
           if ( i == 8 ) { Loc = "nph-count.cgi?password=$password"; } 
           if ( i == 9 ) { Loc = "hs_admin.cgi?action=Create+Banner+Categories&password=$password"; } 
           if ( i == 10 ) { Loc = "hs_admin.cgi?action=Utilities&password=$password"; } 
           if ( i == 11 ) { Loc = "hs_admin.cgi?action=Qualifiers&password=$password"; } 
           if ( i == 12 ) { Loc = "hs_admin.cgi?action=Create+Forums&password=$password"; } 
           if ( i == 13 ) { Loc = "hs_admin.cgi?action=Create+Classifieds&password=$password"; } 
           if ( i == 14 ) { Loc = "nph-optin.cgi?password=$password"; } 

           X=window.open(Loc,"X","toolbar=no,scrollbars=yes,directories=no,resizable=yes,menubar=no,width=625,height=460")
        }

        function OpenNewAdditions(form) {
           Loc = "hs_admin.cgi?action=New+Additions&password=$password";
           X=window.open(Loc,"X","toolbar=no,scrollbars=yes,status=yes,directories=no,resizable=yes,menubar=no,width=625,height=500")
        }

   </SCRIPT>

   <CENTER>
   <TABLE BORDER=1 WIDTH="100%"> 
   <TR BGCOLOR="$title_color">
   <TD><FONT COLOR="$ttxt_color">
   <BR>
   <FORM NAME="admin_form">

   Hyperseek! Utilities: 
      <SELECT NAME="select_utilities">
         <OPTION>Select Utility
         <OPTION>Return to Main Admin Program
         <OPTION>Category Manager
         <OPTION>Generate Mailing List
         <OPTION>Edit Acceptance Email
         <OPTION>Edit Rejection Letters
         <OPTION>Validate Categories
         <OPTION>Create HTML Files
         <OPTION>Update Category Counts
         <OPTION>Create Banner Categories
         <OPTION>Database Manager
         <OPTION>Qualifyers / Refinements

DONE

         print "<OPTION>Create Forums\n";
         print "<OPTION>Create Classifieds\n";
         print "<OPTION>Send Opt-In Email (Updates)\n";


    print <<DONE;

      </SELECT>
      <INPUT TYPE="button" VALUE="Go!" onClick="OpenUtilityWindow(this.form)">

      &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;

      <INPUT TYPE="button" VALUE="New Additions ($NEW)" onClick="OpenNewAdditions()">

      <INPUT TYPE="button" VALUE="Help!" onClick='parent.main.location.href="$manual"'>

      <INPUT TYPE="button" VALUE="Hyperseek Admin Home" onClick='parent.main.location.href="ahyperseek.cgi?action=admin&password=$password"'>

   </FORM>
   </TD></TR></TABLE></CENTER>


DONE



}



### Delete a single message
sub delete_category {


  &admin_readYH;

  open (NEW, "> $cat_data");
     print NEW "\n"; 
     for $i (0 .. $#categories ) {
        if($categories[$i]{'Category'} ne $category) {
           $LINE = "|$categories[$i]{'Category'}|$categories[$i]{'SubCategory'}|$categories[$i]{'Count'}|$categories[$i]{'Moderator'}|$categories[$i]{'ModeratorPW'}";
	   print NEW "$LINE\n";
        } 
     }
  close (NEW);

  open (NEW, "> $sub_data");
     print NEW "\n"; 
     for $i (0 .. $#subcategories ) {
        if($subcategories[$i]{'Category'} ne $category) {
           $LINE = "|$subcategories[$i]{'Category'}|$subcategories[$i]{'SubCategory'}|$subcategories[$i]{'Count'}";
	   print NEW "$LINE\n";
        } 
     }
  close (NEW);



  $ok_message="Category $category Deleted ....";
  $click="self.location.href='hs_admin.cgi?action=Category+Mgr&password=$password'";

  &ok_box($ok_message,$click);

}


###########################################################################
#        __  ___  _                    _____   __            ____  ____
#       /  |/  / (_) _____  _____     / ___/  / /_  __  __  / __/ / __/
#      / /|_/ / / / / ___/ / ___/     \__ \  / __/ / / / / / /_  / /_
#     / /  / / / / (__  ) / /__      ___/ / / /_  / /_/ / / __/ / __/
#    /_/  /_/ /_/ /____/  \___/     /____/  \__/  \__,_/ /_/   /_/
#
###########################################################################

##############################################################################
### Input for Change Database Contents
##############################################################################
sub ChangeCategories {   


   $old_category = $input{'old_category'};
   $new_category = $input{'category'};
   $temp_file = "$engine_data.temp";
  
   open(NEWFILE,">$temp_file");
   open(ALLFILE,"$engine_data");
   foreach $LINE (<ALLFILE>)
	{
	($ID,$Category,$SubCategory,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);


        if ($old_category eq $Category) {

	  print NEWFILE "$ID|";
	  print NEWFILE "$new_category|";
          print NEWFILE "$SubCategory|";
          print NEWFILE "$Crank|";
          print NEWFILE "$Qualifier|";
          print NEWFILE "$Email|";
          print NEWFILE "$Title|";
          print NEWFILE "$URL|";
          print NEWFILE "$Description|";
          print NEWFILE "$string|";
          print NEWFILE "$filler1|";
          print NEWFILE "$filler2|";
          print NEWFILE "$filler3|";
          print NEWFILE "$filler4|";
	  print NEWFILE "\n";
           
        }
        else { print NEWFILE "$LINE"; }
    }

    close(ALLFILE);
    close(NEWFILE);

    ### Backup the original and rename the temp file
    $backup = "$engine_data.bak";
    rename $engine_data, $backup;
    rename $temp_file, $engine_data;



        $ok_message = "Database Updated.";
        #  $click="self.location.href='hs_admin.cgi?action=Utilities&password=$password'";
        $click="self.close();";

        &ok_box($ok_message,$click);

}


##############################################################################
### Input for Change Database Contents
##############################################################################
sub ChangeSubCategories {   




    @entries = split(/\|/,$sub_category);
 
    $new_sub_category = $entries[1];

   $category = $input{'category'};
   $old_sub_category = $input{'old_sub_category'};
   $temp_file = "$engine_data.temp";
  
   open(NEWFILE,">$temp_file");
   open(ALLFILE,"$engine_data");
   foreach $LINE (<ALLFILE>)
	{
	($ID,$Category,$SubCategory,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);


        if ($category eq $Category && $old_sub_category eq $SubCategory) {

	  print NEWFILE "$ID|";
	  print NEWFILE "$Category|";
          print NEWFILE "$new_sub_category|";
          print NEWFILE "$Crank|";
          print NEWFILE "$Qualifier|";
          print NEWFILE "$Email|";
          print NEWFILE "$Title|";
          print NEWFILE "$URL|";
          print NEWFILE "$Description|";
          print NEWFILE "$string|";
          print NEWFILE "$filler1|";
          print NEWFILE "$filler2|";
          print NEWFILE "$filler3|";
          print NEWFILE "$filler4|";
	  print NEWFILE "\n";

        }
        else { print NEWFILE "$LINE"; }
    }

    close(ALLFILE);
    close(NEWFILE);

    ### Backup the original and rename the temp file
    $backup = "$engine_data.bak";
    rename $engine_data, $backup;
    rename $temp_file, $engine_data;

        $ok_message = "Database Updated.<BR>$old_sub_category Changed to: $new_sub_category <BR> In: $category ($Category)";
        # $click="self.location.href='hs_admin.cgi?action=Utilities&password=$password'";
        $click="self.close";

        &ok_box($ok_message,$click);

}



##############################################################################
### Input for Change Database Contents
##############################################################################
sub DBManager {   


        &admin_readYH;

        print "Content-Type: text/html\n\n";

        print "<SCRIPT LANGUAGE=\"javascript\">\n";
	print "function DrawWindow() {\n";
  	print '   X=window.open("","X","toolbar=no,scrollbars=yes,directories=no,resizable=yes,menubar=no,width=625,height=460");';
  	print "}\n\n";

        print "</SCRIPT>\n\n";

	print "<BODY BGCOLOR=\"$pg_color\" LINK=\"#003366\" VLINK=\"#003366\" ALINK=\"#800000\" topmargin=\"10\" leftmargin=\"10\">\n";
 
        print <<DONE1;
        <CENTER><H1>Hyperseek! Utilities</H1>

            <TABLE BORDER=1 WIDTH="90%" CELLSPACING=0 CELLPADDING=0>
              <TR><TD>
                 <TABLE BORDER=0 WIDTH="100%" CELLSPACING=0 CELLPADDING=7>
                    <TR BGCOLOR="$title_color"><TD><FONT COLOR="$ttxt_color" FACE="$font_face">
                       <B>Hyperseek! Utilities</B></TD>
                    </TR>

                    <TR BGCOLOR="$win_color"><TD><FONT COLOR="$text_color" FACE="$font_face"><B>



	                <FORM NAME="msg_form" METHOD="post" ENCTYPE="x-www-form-urlencoded" ACTION="hs_admin.cgi">
	                <INPUT TYPE='hidden' NAME='mode' VALUE='admin'>
                        <INPUT TYPE="hidden" NAME="password" VALUE="$password"></TD>
                    </TR>


                    <TR BGCOLOR="$win_color"><TD><FONT COLOR="$text_color" FACE="$font_face"><B>
	                <U><B>Change Categories in the Database</B></U><BR>
                          Simply enter in the old and new values (we assume that you have 
                          made edits to your category database).  This will update the URL 
                          database to reflect any category changes you made... <BR><BR>
	                  If the category is: <INPUT TYPE="text" NAME="old_category"><BR>
                      ... Change it to:
DONE1


        $JS="F";
        &CategorySelectList;

        print "        <CENTER><INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Change Categories\"></CENTER></FORM><BR>\n";
        print "        <CENTER><HR WIDTH=\"80%\"></CENTER>\n";
        print "     </TD></TR>\n";


        print "     <TR BGCOLOR=\"$win_color\"><TD><FONT COLOR=\"$text_color\" FACE=\"$font_face\"><B>\n";
	print "       <FORM NAME=\"msg_form\" METHOD=\"post\" ENCTYPE=\"x-www-form-urlencoded\" ACTION=\"hs_admin.cgi\">\n";
	print "       <U><B>Change Sub Categories in the Database</B></U><BR>\n";
        print "        Simply enter in the old and new values (we assume that you have made edits to your category database).  This will update the URL database to reflect any category changes you made... <BR><BR>\n";

	print " If the category is:\n";
       
        $JS="F";
        &CategorySelectList;

        print "<BR>\n";

        print " And the sub-category is: <INPUT TYPE=\"text\" NAME=\"old_sub_category\"> <BR>\n";
        print "... Change the Sub Category to:\n";

        $JS="F";
        &SubCategorySelectList;

        print " <BR><CENTER>  <INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Change Subcategories\"><CENTER>\n";


        print " <CENTER><HR WIDTH=\"80%\"></CENTER>\n";
        print "</FORM>\n";

        print "</TD></TR></TABLE>\n";
        print "</TD></TR></TABLE>\n";

	print "</BODY>\n";
	
	print "</HTML>\n";
	
	exit 0;

}

##############################################################################
### Edit a category 
##############################################################################
sub EditCategory {   



       print "Content-type: text/html\n\n";
       print <<DONE_EDIT;

<html>
<head>
  <title>Edit Category</title>
</head>

<body BGCOLOR="$pg_color">
<center>

<form NAME="rply_form" METHOD="POST" ACTION="hs_admin.cgi" ENCTYPE="x-www-form-urlencoded">

<table BORDER="2" CELLSPACING="0" CELLPADDING="0">
   <tr bgcolor="$title_color">
     <td HEIGHT="24"><font size=+1 color="$ttxt_color">Edit Category</font></td></tr>
   <tr bgcolor="$win_color">
     <td>
       <b><font COLOR="$text_color"><PRE>
    Category Title: <input NAME="category" TYPE="text" SIZE="30" MAXLENGTH="40" VALUE="$category"><BR>    Change To:<input NAME="new_category" TYPE="text" SIZE="30" MAXLENGTH="40" VALUE="$category"><BR><BR>

    Moderator     : <input NAME="moderator" VALUE="$moderator" TYPE="text" SIZE="20" MAXLENGTH="40"><BR><BR>

    Moderator Password: <input NAME="moderator_pw" VALUE="$moderator_pw" TYPE="text" SIZE="20" MAXLENGTH="40"><BR><BR>

    Short Description:
    <TEXTAREA NAME="cat_description" ROWS=4 COLS=40 WRAP=virtual>$cat_description</TEXTAREA>

    Sub Categories (One on each line...):
    <TEXTAREA NAME="sub_categories" ROWS=5 COLS=40 WRAP=virtual>$sub_categories</TEXTAREA>

    Deeper Level Sub Categories (One per line):
    <TEXTAREA NAME="deep_subs" ROWS=5 COLS=50>$deep_subs</TEXTAREA>

         <center><input NAME="b_post" TYPE="submit" VALUE="Save"></pre>
         <input NAME="password" TYPE="hidden" VALUE="$password">
         <input NAME="action" TYPE="hidden" VALUE="save_edits"></CENTER></BR>
</td></tr>
</table>
</form></center>
<H2>Please Note:</H2>
<BLOCKQUOTE>
  This will only change the in the "Category Database".
  If you make changes here, and want them to be matched 
  in the LINKS database, you'll need to load
  the Database Utility and make the same changes you make 
  here to the "Links Database".
</BLOCKQUOTE>
</body>

   
</html>

DONE_EDIT
	   
  exit 0;

}


##############################################################################
# Get form input and post new message 
##############################################################################
sub SaveEdits {


  $NewCat = $input{'new_category'};
  $NewCat =~ s/\n//g;
  $new_line = "$NewCat|$sub_categories";


  if ($NewCat =~ tr/;<>*|`&$!#()[]{}:'"\///) { 
      &ERROR("You cannot use non-Alphanumeric characters <BR>in the Category Description<BR><BR>You Entered:<BR><PRE>$NewCat</PRE>"); 
      exit 0;
  }

  if ($sub_categories =~ tr/;<>*|`&$!#()[]{}:'"\///) { 
      &ERROR("You cannot use non-Alphanumeric characters <BR>in your subcategories<BR><BR>You Entered:<BR><PRE>$sub_categories</PRE>"); 
      exit 0;
  }

  if ($deep_subs =~ tr/;<>*|`&$!#()[]{}'"\///) { 
      &ERROR("You cannot use non-Alphanumeric characters <BR>in your deep subcategories (except for a colons and periods \"\: or . \")<BR><BR>You Entered:<BR><PRE>$deep_subs</PRE>"); 
      exit 0;
  }

  $sub_categories =~ s/\r\n/|/g;

  $cat_description =~ s/\cM//g;
  $cat_description =~ s/\n/<BR>/g;

  &admin_readYH;


   open (CNT,">$cat_data");
      print CNT "\n";
      for $x ( 0 .. $#categories ) {
        if ($categories[$x]{'Category'} ne $category) {
            print CNT "|$categories[$x]{'Category'}";
            print CNT "|$categories[$x]{'SubCategory'}";
            print CNT "|$categories[$x]{'Count'}";
            print CNT "|$categories[$x]{'Description'}";
            print CNT "|$categories[$x]{'Moderator'}";
            print CNT "|$categories[$x]{'ModeratorPW'}\n";
        }
      }

      @subs = split(/\|/,$sub_categories);
      for $x (0 .. $#subs) { 
        print CNT "|$NewCat|$subs[$x]|0|$cat_description|$moderator|$moderator_pw\n";
      }
   close(CNT);


   open (DAT,">$sub_data");
      print DAT "\n";
      for $x ( 0 .. $#subcategories ) {
        if ($subcategories[$x]{'Category'} ne $category) {
	    print DAT "|$subcategories[$x]{'Category'}";
	    print DAT "|$subcategories[$x]{'SubCategory'}";
	    print DAT "|$subcategories[$x]{'Count'}\n";
        }
      }

      $deep_subs =~ s/\r\n/|/g;
      @deep = split(/\|/,$deep_subs);
      for $x (0 .. $#deep) { 
        print DAT "|$NewCat|$deep[$x]|0\n";
      }
   close(DAT);




   $ok_message="Edits Saved ....Category: $NewCat ($category)";
   $click="self.location.href='hs_admin.cgi?action=Category+Mgr&password=$password'";

   &ok_box($ok_message,$click);

   exit 0;

}




##############################################################################
### Display and process New Message Window
##############################################################################
sub NewCategory {   



       print "Content-type: text/html\n\n";
       print <<DONE_NEW;

<html>
<head>
  <title>New Category</title>
</head>

<body BGCOLOR="$pg_color">
<B><A HREF="#example">Instructions/Example</A></B>
<center>

<form NAME="rply_form" METHOD="POST" ACTION="hs_admin.cgi" ENCTYPE="x-www-form-urlencoded">

<table BORDER="2" CELLSPACING="0" CELLPADDING="0">
   <tr bgcolor="$title_color">
     <td HEIGHT="24"><font size=+1 color="$ttxt_color">New Category</font></td></tr>
   <tr bgcolor="$win_color">
     <td>
       <b><font COLOR="$text_color"><PRE>
    Category Title: <input NAME="category" TYPE="text" SIZE="30" MAXLENGTH="40">

    Moderator     : <input NAME="moderator" TYPE="text" SIZE="20" MAXLENGTH="40">

    Moderator Password: <input NAME="moderator_pw" TYPE="text" SIZE="20" MAXLENGTH="40">

    Description :
    <TEXTAREA NAME="cat_description" ROWS=3 COLS=50></TEXTAREA>

    Sub Categories (One on each line...):
      These will be the "teasers" on the Hyperseek! home page...

    <TEXTAREA NAME="sub_categories" ROWS=5 COLS=50></TEXTAREA>

    Deeper Level Sub Categories (One on each line...):
      These are the "real" subcategories...

    <TEXTAREA NAME="deep_subs" ROWS=5 COLS=50></TEXTAREA>
         <center><input NAME="b_post" TYPE="submit" VALUE="Save"></pre>
         <input NAME="action" TYPE="hidden" VALUE="post_cat"></CENTER></BR>
         <input NAME="password" TYPE="hidden" VALUE="$password">
</td></tr>
</table>
</form></center>
<A NAME="example">
<BLOCKQUOTE>
<H2>Example</h2>
Lets assume you are creating a links page for a state.  We'll use Pennsylvania as
the example here, and one of the "Teaser" categories you want to create  for the 
front page will be the Major Cities, with deeper sublevels consisting of the various
levels of government, civil services, and tourism.  Take a look below:
<BR><BR>
In the "Category" Field, You would enter: <TT>Major Cities</TT><BR><BR>

In the "SubCategories" Field, enter the cities you'll be focusing on, each on
it's own line.  The cities you enter here will be listed under the heading of
"Major Cities" on the Hyperseek! main page.  For Example:<BLOCKQUOTE>
<PRE>
Harrisburg
Philadelphia
Pittsburgh
</PRE>
</BLOCKQUOTE>

Now, in the "Deeper Subcategories Section, you'll need to enter the actual
breakdown of subcategories for each city, again, one per line.  If you want to 
allow for the addition of links under the main subcategory, then you'll need to
enter it here as well. <BR><BR>
Each "Deeper Subcategory" consists of the Subcategory, followed by a colon (":").
If you will be going deeper than just one level, then separate each level with 
a colon as well.  For Example:<BLOCKQUOTE>
<PRE>
Philadelphia:City Government
Philadelphia:City Government:Mayors Office
Philadelphia:City Government:Office of Tourism
Philadelphia:City Government:Chief of Police
Philadelphia:City Government:Sanitation Department
Philadelphia:Recreation
Philadelphia:Recreation:Professional Sports:Flyers Hockey
Philadelphia:Recreation:Professional Sports:Sixers Basketball
Philadelphia:Recreation:Professional Sports:Eagles Football
Philadelphia:Recreation:Professional Sports:Phillies Baseball
Philadelphia:Recreation:Tourist Activities
Philadelphia:Recreation:Tourist Activities:Historic Tours
Philadelphia:Recreation:Tourist Activities:Arts and Museums
Philadelphia:Recreation:Tourist Activities:Dining and Theatre
Philadelphia:Recreation:Tourist Activities:Outdoors Activities
</PRE> 
.... And so on.<BR>
You would repeat the same process for Pittsburgh, and Harrisburg, all
in this same entry field to complete the process for the "Major Cities"
Cagegory.  You would do the same for each Major Category that you plan 
to define.
</BLOCKQUOTE>

</BLOCKQUOTE>
</body>

   
</html>
	   
DONE_NEW
  exit 0;

}


##############################################################################
# Get form input and post new message 
##############################################################################
sub PostCategory {


        $cat_description =~ s/\cM//g;
        $cat_description =~ s/\n/<BR>/g;


        if ($category =~ tr/;<>*|`&$!#()[]{}:'"\///) { 
            &ERROR("You cannot use non-Alphanumeric characters <BR>in the Category Description<BR><BR>You Entered:<BR><PRE>$NewCat</PRE>"); 
            exit 0;
        }
      
        if ($sub_categories =~ tr/;<>*|`&$!#()[]{}:'"\///) { 
            &ERROR("You cannot use non-Alphanumeric characters <BR>in your subcategories<BR><BR>You Entered:<BR><PRE>$sub_categories</PRE>"); 
            exit 0;
        }

        if ($deep_subs =~ tr/;<>*|`&$!#()[]{}'"\///) { 
            &ERROR("You cannot use non-Alphanumeric characters <BR>in your deep level subcategories (except for a colons and periods \"\: or . \")<BR><BR>You Entered:<BR><PRE>$deep_subs</PRE>"); 
            exit 0;
        }


	open (CNT,">>$cat_data");
          $sub_categories =~ s/\r\n/|/g;
          @cats = split(/\|/,$sub_categories);
          for $x( 0 .. $#cats ) {
	    print CNT "|$category";
            print CNT "|$cats[$x]|0";
            print CNT "|$cat_description";
            print CNT "|$moderator";
            print CNT "|$moderator_pw";
	    print CNT "\n";
          }
	close(CNT);

        $deep_subs =~ s/\r\n/|/g;
        @entries = split(/\|/,$deep_subs);
	open (DAT,">>$sub_data");
        for $x( 0 .. $#entries ) {
	  print DAT "|$category|";
          print DAT "$entries[$x]|0";
	  print DAT "\n";
        }
	close(DAT);


	$ok_message="The following Category was created...";
        $click="self.location.href='hs_admin.cgi?action=Category+Mgr&password=$password'";

	&ok_box($ok_message,$click);
}



##############################################################################
### Read categories file (admin mode)
##############################################################################
sub CategorySelectList { 


    if ($JS eq "T") {

       print "parent.work.document.writeln('Category:      <SELECT NAME=\"category\">');";

       $LastCategory = "";
       for $x (0 .. $#categories ) {

        $ThisCategory = $categories[$x]{'Category'};
        if ($ThisCategory ne $LastCategory) { 
            $LastCategory = $ThisCategory ; 
            print "parent.work.document.writeln('<OPTION VALUE=\"$ThisCategory\">$ThisCategory');";
         }
       }

       print "parent.work.document.writeln('</SELECT><BR>');";

    }

    else {

       print "Category:      <SELECT NAME=\"category\">\n";

       $LastCategory = "";
       for $x (0 .. $#categories ) {

        $ThisCategory = $categories[$x]{'Category'};
        if ($ThisCategory ne $LastCategory) { 
 
            $LastCategory = $ThisCategory ; 

            if ($ThisCategory eq $category) {
               print "<OPTION VALUE=\"$ThisCategory\" SELECTED>$ThisCategory\n";
            }
            else { 
               print "<OPTION VALUE=\"$ThisCategory\">$ThisCategory\n"; 
            }
         }
       }

       print "</SELECT><BR>\n";
    } 




}

##############################################################################
### Read categories file (admin mode)
##############################################################################
sub SubCategorySelectList { 



       print "Sub Category:  <SELECT NAME=\"sub_category\">\n";

       $Match="F";

       for $y (0 .. $#subcategories ) {

          if ($subcategories[$y]{'SubCategory'} eq $sub_category) {
             $Match="T";
             print "<OPTION VALUE=\"$subcategories[$y]{'Category'}|$subcategories[$y]{'SubCategory'}\" SELECTED>$subcategories[$y]{'Category'} ... $subcategories[$y]{'SubCategory'}\n";

          }

          else {

             print "<OPTION VALUE=\"$subcategories[$y]{'Category'}|$subcategories[$y]{'SubCategory'}\">$subcategories[$y]{'Category'} ... $subcategories[$y]{'SubCategory'}\n";

          }

       }

       if($Match ne "T") { 
          print "<OPTION VALUE=\"DEFAULT|$sub_category\" SELECTED>Suggestion: $sub_category\n";
       }
       print "<OPTION VALUE=\"DEFAULT|DEFAULT\">Default Group\n";
           
       print "</SELECT><BR>\n";


}








sub Edit_Email {


  $n='\r\n';
  open(MAIL,"$data_dir/hyperseek.send");
     @lines = <MAIL>;
     for $x(0 .. $#lines) {
        $EMAIL .= $lines[$x];
     }
     $EMAIL =~ s/\cM//g;
  close(MAIL);


	print "Content-type: text/html\n\n";

        print <<END_EDIT;
<HTML>

  <body BGCOLOR="$pg_color">
    <form NAME="head_foot" METHOD="POST" ACTION="hs_admin.cgi" ENCTYPE="x-www-form-urlencoded">

      <B><U>Custom Email:</B></U><BR>
        <BLOCKQUOTE>
        Enter the Text to be sent in the eamil that your submitters will recieve when you approve their listing. 
        <PRE>
    You can use the following "Special" Variable in your email, 
    to personalize it....

    -- VARIABLE --      -- MEANING --
    ---------------   -----------------------------------------
    [ID]              The ID Number for this entry 
    [CATEGORY]        The category in which it will appear
    [SUBCATEGORY]     The sub category in which it will appear
    [URL]             The URL for this entry
    [TITLE]           The Title (link text)
    [DESCRIPTION]     Description Displayed below the link
    [KEYWORDS]        Terms this listing can be found by

  Also, if you would like to make use of the built-in "voting" system, please
  include the following code in the email text, substituting, the correct
  URLs for YOUR server, in the correct places...

  &lt;TABLE BORDER=0&gt;&lt;TR&gt;&lt;TD&gt;
  &lt;A HREF="http://www.WHATEVER.com/WHEREVER/vote.cgi?ID=[ID]"&gt;
  &lt;IMG SRC="http://www.WHATEVER.com/images/top10.jpg BORDER="0"&gt;&lt;/A&gt;&lt;/TD&gt;&lt;/TR&gt;
  &lt;TR&gt;&lt;TD&gt;Vote for this site "Top of the 'Net"&lt;/TD&gt;&lt;/TR&gt;&lt;/TABLE&gt; 
        </PRE></BLOCKQUOTE>
      <TEXTAREA NAME="email_text" COLS=65 ROWS=20>$EMAIL</TEXTAREA><BR><HR><BR>

      <CENTER><INPUT TYPE="submit" NAME="action" VALUE="Save Email"></CENTER>

      <CENTER><INPUT TYPE="hidden" NAME="password" VALUE="$password"></CENTER>
      <BLOCKQUOTE>
      <PRE>
      </PRE>
      </BLOCKQUOTE>
    </FORM>
   </BODY>
</html>

END_EDIT

        exit 0;


}



sub Save_Email {

    $EMAIL = $input{'email_text'};
    $HEADER =~ s/\cM//g;

    open(MAIL,">$data_dir/hyperseek.send") || ERROR("Cant Open mail file");
       print MAIL "$EMAIL";
    close(MAIL);

    $ok_message =  "</CENTER><P><P><CENTER><H3>Your Custom Thank-You Email will now be used .... </H3><BR></CENTER><PRE>$EMAIL</PRE><CENTER>\n";
    $click="self.close()";
    &ok_box($ok_message,$click);

    exit 0;

}



sub Edit_Rejection {


  $n='\r\n';

  open(R1,"$data_dir/reject1.send");
     @lines = <R1>;
     for $x(0 .. $#lines) {
        $REJECT1 .= $lines[$x];
     }
     $REJECT1 =~ s/\cM//g;
  close(R1);

  open(R2,"$data_dir/reject2.send");
     @lines = <R2>;
     for $x(0 .. $#lines) {
        $REJECT2 .= $lines[$x];
     }
     $REJECT2 =~ s/\cM//g;
  close(R2);

  open(R3,"$data_dir/reject3.send");
     @lines = <R3>;
     for $x(0 .. $#lines) {
        $REJECT3 .= $lines[$x];
     }
     $REJECT3 =~ s/\cM//g;
  close(R3);

  open(RT,"$data_dir/reject_mail.titles");
     @titles = <RT>;
  close(RT);

  $reject1 = $titles[0];  
  $reject2 = $titles[1];  
  $reject3 = $titles[2];  

  $reject1 =~ s/\n//g;
  $reject2 =~ s/\n//g;
  $reject3 =~ s/\n//g;

  $reject1 =~ s/\cM//g;
  $reject2 =~ s/\cM//g;
  $reject3 =~ s/\cM//g;


	print "Content-type: text/html\n\n";

        print <<END_EDIT;
<HTML>

  <body BGCOLOR="$pg_color">
    <form NAME="head_foot" METHOD="POST" ACTION="hs_admin.cgi" ENCTYPE="x-www-form-urlencoded">

      <B><U>Custom Email:</B></U><BR>
        <BLOCKQUOTE>
        Hyperseek allows you send one of 3 rejection letters to your submitters when you choose not to add their listing.
        Below, you can define each of them...
        </BLOCKQUOTE>
      Reject Letter 1.... <BR>
      Letter Name: <INPUT NAME="reject1" VALUE="$reject1"><BR>
      Letter Text:<BR>
      <TEXTAREA NAME="reject1_text" COLS=65 ROWS=20>$REJECT1</TEXTAREA><BR><HR><BR>

      Reject Letter 2.... <BR>
      Letter Name: <INPUT NAME="reject2" VALUE="$reject2"><BR>
      Letter Text:<BR>
      <TEXTAREA NAME="reject2_text" COLS=65 ROWS=20>$REJECT2</TEXTAREA><BR><HR><BR>

      Reject Letter 3.... <BR>
      Letter Name: <INPUT NAME="reject3" VALUE="$reject3"><BR>
      Letter Text:<BR>
      <TEXTAREA NAME="reject3_text" COLS=65 ROWS=20>$REJECT3</TEXTAREA><BR><HR><BR>

      <CENTER><INPUT TYPE="hidden" NAME="password" VALUE="$password"></CENTER>
      <CENTER><INPUT TYPE="submit" NAME="action" VALUE="Save Rejection Letters"></CENTER>


    </FORM>
   </BODY>
</html>

END_EDIT

        exit 0;


}



sub Save_Rejection {

    $reject1 = $input{'reject1'};
    $reject2 = $input{'reject2'};
    $reject3 = $input{'reject3'};

    $REJECT1 = $input{'reject1_text'};
    $REJECT2 = $input{'reject2_text'};
    $REJECT3 = $input{'reject3_text'};

    $HEADER =~ s/\cM//g;

    open(TITLES, ">$data_dir/reject_mail.titles");
       print TITLES "$reject1\n";
       print TITLES "$reject2\n";
       print TITLES "$reject3\n";
    close(TITLES);

    open(MAIL1,">$data_dir/reject1.send") || &ERROR("Cant Open mail file");
       print MAIL1 "$REJECT1";
    close(MAIL1);

    open(MAIL2,">$data_dir/reject2.send") || &ERROR("Cant Open mail file");
       print MAIL2 "$REJECT2";
    close(MAIL2);

    open(MAIL3,">$data_dir/reject3.send") || &ERROR("Cant Open mail file");
       print MAIL3 "$REJECT3";
    close(MAIL3);


    $ok_message =  "<P><P><CENTER><H3>Your Custom Rejection Letters will now be used .... <BR>\n";
    $click="self.close()";
    &ok_box($ok_message,$click);

    exit 0;

}



sub Qualifiers {


   if ($yh_qualify ne "Yes") {
       $ok_message =  "<BR><BR>\n";
       $ok_message .=  "<FONT COLOR=\"red\"><H4>\n";
       $ok_message .=  "<BLOCKQUOTE>You have not elected to use Qualifiers/Refinements.\n";
       $ok_message .=  " If you wish to use them, please go to the main admin program, select Configure\n";
       $ok_message .=  " and turn this feature on.</H4></BLOCKQUOTE></FONT>\n";
       $click="self.close()";
       &ok_box($ok_message,$click);
       exit 0;
   }


   open("Q","$data_dir/qualifiers.dat"); # || &ERROR("Could Not open Qualifier Database for read");
      @qualifiers=<Q>;
   close(Q);

   for $x( 0 .. $#qualifiers ) {
       $qualifiers[$x] =~ s/\cM//g;
       $qualifiers[$x] =~ s/\n//g;

       $text .= "$qualifiers[$x]\n";

   }



   print "Content-Type: text/html\n\n";

   print <<DONE;
        <CENTER>
            <FORM ACTION="hs_admin.cgi" METHOD="post">
            <TABLE BORDER=1 WIDTH="90%" CELLSPACING=0 CELLPADDING=0>
              <TR><TD>
                 <TABLE BORDER=0 WIDTH="100%" CELLSPACING=0 CELLPADDING=7>
                    <TR BGCOLOR="$title_color"><TD><FONT COLOR="$ttxt_color" FACE="$font_face">
                       <B>Hyperseek! Qualifiers</B></TD>
                    </TR>

                    <TR BGCOLOR="$win_color"><TD>
                       <CENTER>
                       <TEXTAREA NAME="qualifiers" ROWS=15 COLS=60>$text</TEXTAREA><BR>
                      <INPUT TYPE="hidden" NAME="password" VALUE="$password">
                      <INPUT TYPE="submit" NAME="action" VALUE="Save Qualifiers">
                    </TD></TR></TABLE>
              </TD></TR></TABLE>
              </FORM>
              

DONE

}


sub Save_Qualifiers {

   $qualifiers = $input{'qualifiers'};
   open("Q",">$data_dir/qualifiers.dat") || &ERROR("Could Not open Qualifier Database for write");
      print Q $qualifiers;
   close(Q);


   $ok_message =  "<BR><BR>\n";
   $ok_message .=  "<FONT COLOR=\"navy\"><H4>\n";
   $ok_message .=  "<BLOCKQUOTE>Your qualifiers have been saved and will take \n";
   $ok_message .=  " effect the next time you are in the Hyperseek Engine.\n";
   $ok_message .=  " </H4></BLOCKQUOTE></FONT>\n";
   $click="self.close()";
   &ok_box($ok_message,$click);
   exit 0;

}

sub ListQualifiers {

        if ($yh_qualify eq "Yes") {
            print "<SELECT NAME=\"Qualifier\">\n";

               open("Q","$data_dir/qualifiers.dat");
                 @qualifiers=<Q>;
               close(Q);

               if ($Qualifier) {print "<OPTION VALUE=\"$Qualifier\">$Qualifier\n";} 
               print "<OPTION VALUE=\"NONE\">No Refinement\n";
               for $x(0 .. $#qualifiers) {
                  $qualifiers[$x] =~ s/\n//g;
                  $qualifiers[$x] =~ s/\cM//g;
                  print "<OPTION VALUE=\"$qualifiers[$x]\">$qualifiers[$x]\n";
               }
            print "</SELECT>\n";
        }

}




##############################################################################
### Read categories file (admin mode)
##############################################################################
sub admin_readYH {


  ### New Category Things..
    open (CNT,"$cat_data");
      while ( <CNT> ) {
        $tmp_cats={};
        foreach $rec(split /\n/,join '',<CNT>){
 	  (undef,
	   @{$tmp_cats[$cat_count++]}{qw(Category SubCategory Count Description Moderator ModeratorPW)})=split(/\|/,$rec,7);
        }
      }
    close (CNT);  

    @categories = sort { $a->{'Category'} cmp $b->{'Category'} } @tmp_cats;


  ### Deep Subs ....
    open (CAT,"$sub_data");
      while ( <CAT> ) {
        $tmp_subs={};
        foreach $rec(split /\n/,join '',<CAT>){
 	  (undef,
	   @{$tmp_subs[$sub_count++]}{qw(Category SubCategory Count)})=split(/\|/,$rec,4);
        }
      }
    close (CAT);  

    @subcategories = sort { $a->{'Category'} cmp $b->{'Category'} 
      or  $a->{'SubCategory'} cmp $b->{'SubCategory'} } @tmp_subs;
}
