#!/usr/local/bin/perl
##############################################################################
# Hyperseek Search Engine                                                    #
# Copyright 2000 John Cokos     jcokos@ccs.net                               #
# Created 05/01/2000            Last Modified 05/16/2000                     #
# Script Home Page:            http://www.interactive-web.net                #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# The Hyperseek Search Engine, including all files in the this distribution  #
# may be modified only by registered users so long as...                     #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
#  _                           _   _                                         #
# | \ _  ._  __|_ |\/| _  _|o_|_  |_) _ | _      _|_|_ o _ ._  _ o.__|_ |    #
# |_/(_) | |(_)|_ |  |(_)(_|| |\/ |_)(/_|(_)\/\/  |_| ||_> |_)(_)|| ||_ o    #
#                              /                           |                 #
##############################################################################

   require ("iweb.pm");
   &parse_form;

   #### File names / etc sent from html
   $engine_data = "$data_dir/hyperseek.dat";
   $engine_temp = "$data_dir/hyperseek.temp";
   $sub_data = "$data_dir/subcategories.dat";
   $cat_data = "$data_dir/categories.dat";

   $total_links = 0;


$PROGRAM="Hyperseek Search Engine Counter";
$VERSION="6.01";

$| = 1;

   &admin_readYH;


   print "HTTP/1.0 200 OK\n";
   print "Content-Type: text/html\n\n";
   print "<PRE>Working ...";

    ### Re-Set the Counters
    for $x( 0 .. $#subcategories ) { $subcategories[$x]{'Count'} = 0; }
    for $x( 0 .. $#categories ) { $categories[$x]{'Count'} = 0; }


    ### Generate new Counts
    $delimiter = '|';
    open(ALLFILE,"$engine_data");

       foreach $LINE (<ALLFILE>) {
	($ID,$Category,$SubCategory,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);

            for $x( 0 .. $#subcategories ) {
                if ($subcategories[$x]{'Category'} eq $Category && $SubCategory =~ $subcategories[$x]{'SubCategory'}) {
                    $subcategories[$x]{'Count'}++;
                }
            }
        
            for $i( 0 .. $#categories ) {
                if ($categories[$i]{'Category'} eq $Category && $SubCategory =~ $categories[$i]{'SubCategory'}) {
                    $categories[$i]{'Count'}++;
                }
            } 

            print "...";
 
            $total_links ++;

       }

    close(ALLFILE);


    ### Save this new information....
    open (CNT,">$cat_data");
      print CNT "\n";
      for $i ( 0 .. $#categories ) {
        print CNT "|$categories[$i]{'Category'}";
        print CNT "|$categories[$i]{'SubCategory'}";
        print CNT "|$categories[$i]{'Count'}\n";
      }
    close(CNT);

    ### Save this new information....
    open (DAT,">$sub_data");
      print DAT "\n";
      for $x ( 0 .. $#subcategories ) {
        print DAT "|$subcategories[$x]{'Category'}";
        print DAT "|$subcategories[$x]{'SubCategory'}";
        print DAT "|$subcategories[$x]{'Count'}\n";
      }
    close(DAT);


    open (TOT,">$data_dir/hyperseek.total");
       print TOT $total_links;
    close(TOT);


    print "DONE.\n\n</PRE><H1>Counts Updated As Follows...</H1></CENTER>";

    print "<B><U>Main Category Counts</U><B><BR>\n";
    for $x( 0 .. $#categories ) {
        print "<PRE>$categories[$x]{'Category'}::$categories[$x]{'SubCategory'} ... Count:$categories[$x]{'Count'}</PRE>\n";
    } 

    print "<BR><BR><B><U>Sub Category Counts</U><B><BR>\n";
    for $x( 0 .. $#subcategories ) {
        print "<PRE>$subcategories[$x]{'Category'}::$subcategories[$x]{'SubCategory'} ... Count:$subcategories[$x]{'Count'}</PRE>\n";
    } 

    print "<B>Finished: $total_links Total</B>";

    exit 0;



##############################################################################
### Read categories file (admin mode)
##############################################################################
sub admin_readYH {


  ### New Category Things..
    open (CNT,"$cat_data");
      while ( <CNT> ) {
        $categories={};
        foreach $rec(split /\n/,join '',<CNT>){
 	  (undef,
	   @{$categories[$cat_count++]}{qw(Category SubCategory Count Moderator ModeratorPW)})=split(/\|/,$rec,6);
        }
      }
    close (CNT);  

  ### Deep Subs ....
    open (CAT,"$sub_data");
      while ( <CAT> ) {
        $subcategories={};
        foreach $rec(split /\n/,join '',<CAT>){
 	  (undef,
	   @{$subcategories[$sub_count++]}{qw(Category SubCategory Count)})=split(/\|/,$rec,4);
        }
      }
    close (CAT);  

}


