#!/usr/local/bin/perl
##############################################################################
# JavaScript Mailing System (mailman.cgi)                                    #
# Copyright 2000 John Cokos     jcokos@ccs.net                               #
# Created 05/01/2000            Last Modified 05/16/2000                     #
# Script Home Page:            http://www.interactive-web.net                #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# The CCS MailMan Management System, which includes all files in the original#
# distribution may be modified only by registered users so long as...        #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
#  _                           _   _                                         #
# | \ _  ._  __|_ |\/| _  _|o_|_  |_) _ | _      _|_|_ o _ ._  _ o.__|_ |    #
# |_/(_) | |(_)|_ |  |(_)(_|| |\/ |_)(/_|(_)\/\/  |_| ||_> |_)(_)|| ||_ o    #
#                              /                           |                 #
##############################################################################



  require("iweb.pm");
  &parse_form;

  ## Images and HTML Locations
  $manual = $html_dir."/mail_manual.htm";

  $PROGRAM = "Mailman List Manager";
  $VERSION = "3.30";


  # Assign variables based on user input
  $to = $input{'mailto'};
  $from_name = $input{'required-from_name'};
  $from_mail = $input{'required-from_mail'};
  $subject = $input{'subject'};
  $go_to = $input{'success'};
  $u_email = $input{'email'};
  $body = $input{'body'};

  $mail_list = $input{'mailing_list'};

  $password = $input{'password'};
  $mode = $input{'mode'};

  $n='\r\n';
  $q='\"';

  # What do we do ???
  $action = $input{'action'};
   
   
  if ($action eq "add") {&add_user;}
  if ($action eq "add_new") {&add_window;}
  if ($action eq "add_mail") {&add_mail;}
  if ($action eq "new_mail") {&new_mail;}
  if ($action eq "edit_mail") {&edit_mail;}
  if ($action eq "del_mail") {&del_mail;} 
  if ($action eq "create_mail") {&create_mail;}
  if ($action eq "new_list") {&new_list;}
  if ($action eq "Create New List") {&create_list;}
  if ($action eq "del_list") {&del_list;}
  if ($action eq "Delete List") {&delete_list;}

  if ($action eq "admin") {&admin_mail;}
  if ($action eq "menu") {&nav_bar;}
  if ($action eq "login") {&ccs_login("mailman.cgi");}

  if ($action eq "") {&ccs_login("mailman.cgi");} 


  ##############################################################
  #  If all else fails...
  ##############################################################


	print "Content-type: text/html\n\n";

  	print "<HEAD>\n";
    	print "<TITLE>User Login Screen</TITLE>\n";
  	print "</HEAD>\n";

	print "<BODY>\n";
	print "<CENTER><H1>This program was called incorrectly</H1></CENTER>\n";
	print "</BODY>\n";

	print "</HTML>\n";


   exit 0;



###################################################################
##   Form to create a new mailing list
###################################################################
sub new_list {


   print "Content-Type: text/html\n\n";
   print <<DONE;

   <FORM ACTION="mailman.cgi">
   <CENTER>
   <TABLE BORDER=1 CELLPADDING=0 CELLSPACING=0>
   <TR><TD>
     <TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
       <TR BGCOLOR="$title_color"><TD><FONT COLOR="$ttxt_color">
          <B>Create New Mailing List</B></TD>
       </TR>
       <TR BGCOLOR="$win_color"><TD><FONT COLOR="$text_color">
           <BR>
           List Name (One Word Only!): <INPUT NAME="mailing_list"><BR><BR>
           <CENTER><INPUT TYPE="submit" NAME="action" VALUE="Create New List">
       </TD><TR></TABLE>
   </TD><TR></TABLE>
   </FORM>

DONE

   exit 0;

}


###################################################################
##   Physically create the mailing list file
###################################################################
sub create_list {

   open ("NEW", ">$data_dir/maillists/$mail_list.mail") || &ERROR("Could not create file ($!)");
      print NEW "\n";
   close (NEW);


   $ok_message = "<H1>Mailing list $mail_list Created.</h1>";
   $click = "history.go(-1)";

   &ok_box($ok_message,$click);
}


###################################################################
##   Form to select a list to delete
###################################################################
sub del_list {


   print "Content-Type: text/html\n\n";
   print <<DONE;

   <FORM ACTION="mailman.cgi">
   <CENTER>
   <TABLE BORDER=1 CELLPADDING=0 CELLSPACING=0>
   <TR><TD>
     <TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
       <TR BGCOLOR="$title_color"><TD><FONT COLOR="$ttxt_color">
          <B>Delete Mailing List</B></TD>
       </TR>
       <TR BGCOLOR="$win_color"><TD><FONT COLOR="$text_color">
           <BR>
           Select List to Delete: <SELECT NAME="mailing_list">

DONE

        &ReadLists;

	for $x (0 .. $#mailing_lists) { 
	   print "<OPTION VALUE=\"$mailing_lists[$x]\">$mailing_lists[$x]\n";
	}

print <<DONE2;

           </SELECT>
            <BR><BR>
           <CENTER><INPUT TYPE="submit" NAME="action" VALUE="Delete List">
       </TD><TR></TABLE>
   </TD><TR></TABLE>
   </FORM>

DONE2

   exit 0;

}


###################################################################
##   Delete the mailing list file
###################################################################
sub delete_list {

   unlink ("$data_dir/maillists/$mail_list.mail") || &ERROR("Could not delete $mail_list ($!)");

   $ok_message = "<H1>Mailing list $mail_list Deleted.</h1>";
   $click = "history.go(-1)";

   &ok_box($ok_message,$click);
}


###################################################################
##   Read in the mailing list names
###################################################################
sub ReadLists {

    opendir(FILES, "$data_dir/maillists/") || die ERROR("Can't open directory $data_dir/maillists/");
    while($file = readdir(FILES)) {
        if($file =~ /.*\.mail/ ) {
           $file =~ s/.mail//g;
           push @mailing_lists, $file;
        }
    }

}


##############################################################################
# Add a user to a mailing  list
##############################################################################
sub add_mail {
  
   $list = "$data_dir/maillists/$mail_list.mail";
   open(MAIL,">> $list");
     print MAIL "$u_email\n";
   close(MAIL);

   # Set Permissions on New File...
   if ($windows ne "Y" && $windows ne "y") {
      `chmod 666 $list`;
   }

   ### Let them know the operation was a success.

	print "Content-type: text/html\n\n";
	print "<HTML>\n";
	print "<HEAD><TITLE>Welcome</TITLE></HEAD>\n";
	print "<SCRIPT LANGUAGE=\"javascript\">\n";
	print "</SCRIPT>\n";
	print "<BODY>\n";
	print "<FORM>\n";
	print "<P><P><CENTER><H2>Addition to Mailing List: $mail_list Complete<BR>\n";
	print "Press the OK button to continue<P>\n";
	print "Thank you.</H2></CENTER>\n";
	print "<CENTER>\n";
	print "<P><P><P><INPUT TYPE=\"button\" NAME=\"b_ok\" VALUE=\"OK\" onClick=\"self.close()\">\n";
	print "</CENTER>\n";
	print "</FORM>\n";
	print "</BODY>\n";
	print "</HTML>\n";
	
	
	exit 0;
}


##############################################################################
# Input form to get added to a mailing list
##############################################################################
sub new_mail {

        &ReadLists;

	print "Content-type: text/html\n\n";
    	print "<HTML>\n";
    	print "<HEAD>\n";
    	print "<TITLE>Add Name to Mail List</TITLE>\n";
    	print "</HEAD>\n";

	print "<SCRIPT LANGUAGE=\"javascript\">\n";
	print "    function CheckMe() {\n";
	print "       i = document.nm_form.mailing_list.selectedIndex;\n";
	print "       if(i == 0) {\n";
	print "          alert(\"Select a Mailing List\");\n";
	print "          document.nm_form.mailing_list.focus();\n";
	print "          return false;\n";
	print "       }\n";
	print "    }\n";
	print "</SCRIPT>\n";

    	print "<BODY BGCOLOR=\"$pg_color\" onLoad=\"document.nm_form.mailing_list.focus()\">\n";
    	print "<P>\n";
	print "<CENTER>\n";
    	print "<FORM NAME=\"nm_form\" METHOD=\"POST\" ACTION=\"mailman.cgi\" ENCTYPE=\"x-www-form-urlencoded\" onSubmit=\"return CheckMe();\">\n";
    	print "<TABLE BORDER=\"1\" CELLSPACING=\"0\" CELLPADDING=\"10\" COLOR=\"$win_color\">\n";
    	print "<TR BGCOLOR=\"$title_color\">\n";
    	print "<TD><CENTER><B><FONT COLOR=\"$ttxt_color\">Add name to Mailing List</FONT></B></CENTER></TD></TR>\n";
    	print "<TR BGCOLOR=\"$win_color\">\n";
    	print "<TD><FONT COLOR=\"$text_color\"> Mailing List: </FONT> \n";
	print "<SELECT NAME=\"mailing_list\">\n";
	print "<OPTION VALUE=\"Select Mailing List\">Select Mailing List\n";

	for $x (0 .. $#mailing_lists) { 
	   print "<OPTION VALUE=\"$mailing_lists[$x]\">$mailing_lists[$x]\n";
	}

	print "</SELECT><P>\n";
    	print "<FONT COLOR=\"$text_color\"> Email Address:</FONT>\n"; 
	print "<INPUT TYPE=\"text\" SIZE=\"30\" NAME=\"email\"><P>\n";
    	print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"add_mail\"><BR>\n";
    	print "<CENTER><INPUT NAME=\"submit\" TYPE=\"submit\" VALUE=\"Add Me\">\n";
    	print "<INPUT NAME=\"clear\" TYPE=\"reset\" VALUE=\"Clear Form\"></CENTER><P></TD></TR>\n";
    	print "</TABLE>\n";
    	print "</FORM>\n";
    	print "</CENTER>\n";
    	print "</BODY>\n";
	print "</HTML>\n";

	exit 0;

}


##############################################################################
# Generate and send the mail
##############################################################################
sub create_mail {


        &ReadLists;

	print "Content-type: text/html\n\n";
    	print "<HTML>\n";
    	print "<HEAD>\n";
    	print "<TITLE>Create Mailing...</TITLE>\n";
    	print "</HEAD>\n";
    	print "<BODY BGCOLOR=\"$pg_color\" onLoad=\"document.nm_form.mailing_list.focus()\">\n";
    	print "<P>\n";
	print "<CENTER>\n";
    	print "<FORM NAME=\"nm_form\" METHOD=\"POST\" ACTION=\"nph-mail.cgi\" ENCTYPE=\"x-www-form-urlencoded\">\n";
    	print "<TABLE BORDER=\"1\" CELLSPACING=\"0\" CELLPADDING=\"10\" COLOR=\"$win_color\">\n";
    	print "<TR BGCOLOR=\"$title_color\">\n";
    	print "<TD><CENTER><B><FONT COLOR=\"$ttxt_color\">Create Mailing...</FONT></B></CENTER></TD></TR>\n";
    	print "<TR BGCOLOR=\"$win_color\">\n";
    	print "<TD><FONT COLOR=\"$text_color\"> Mailing List: </FONT> \n";
	print "<SELECT NAME=\"mailing_list\">\n";

	for $x (0 .. $#mailing_lists) { 
	   print "<OPTION VALUE=\"$mailing_lists[$x]\">$mailing_lists[$x]\n";
	}

	print "</SELECT><P>\n";
    	print "<FONT COLOR=\"$text_color\"> Subject: </FONT>\n"; 
	print "<INPUT TYPE=\"text\" SIZE=\"30\" NAME=\"subject\"><P>\n";
	print "<TEXTAREA NAME=\"body\" ROWS=10 COLS=65></TEXTAREA>\n";
    	print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"send\"><BR>\n";
    	print "<INPUT TYPE=\"hidden\" NAME=\"password\" VALUE=\"$password\"><BR>\n";
    	print "<CENTER><INPUT NAME=\"submit\" TYPE=\"submit\" VALUE=\"Send It!\">\n";
    	print "<INPUT NAME=\"clear\" TYPE=\"reset\" VALUE=\"Clear Form\"></CENTER></TD></TR>\n";
    	print "</TABLE>\n";
    	print "</FORM>\n";
    	print "</CENTER>\n";
    	print "</BODY>\n";
	print "</HTML>\n";

	exit 0;



}


##############################################################################
# Window to show contents of mailing list and allow deletion
##############################################################################
sub edit_mail {


        &ReadLists;

        $currList = "$data_dir/maillists/$mail_list.mail";
	open(MAIL,"$currList");
	   @list_entries = <MAIL>;
	close(MAIL);
 
	# Get HTML Together

	$ArraySize=$#mailing_lists + 1;

	print "Content-type: text/html\n\n";
  	print "<HTML>\n";
 	print "<HEAD>\n";
 	print "  <TITLE>Mailing Lists</TITLE>\n";
 	print "</HEAD>\n";
	print "<SCRIPT LANGUAGE=\"javascript\">\n\n";

	print "var CurrentEntry=\"\";\n";

	print "function GetSelectedIndex() {\n";
	print "    return document.msg_form.Entries.selectedIndex\n";
	print "}\n\n";

	print "function DelEntry(form) {\n";
	print "   i = form.mailing_list.selectedIndex;\n";
	print "   var selected_entry=GetSelectedIndex();\n";
	print "   var DeleteMe = v_email[selected_entry];\n";
	print "   var List = areaOptions[i];\n";
	print "   var Loc = \"mailman.cgi?action=del_mail&mailing_list=\" + List + \"&email=\" + DeleteMe;\n";
	print "   document.location = Loc;\n"; 
	print "}\n\n";

	print "function ShowText() {\n";
	print "   var selected_file=GetSelectedIndex();\n";
	print "   CurrentEntry = v_email[selected_file];\n";
	print "}\n\n";

        print "function jumpPage(form) {\n";
	print "   i = form.mailing_list.selectedIndex;\n";
	print "   var Loc=\"mailman.cgi?action=edit_mail&mailing_list=\" + areaOptions[i];"; 
	print "\n";
	print "   this.location.href = Loc;\n";
	print "}  \n";

	### Get Array Functions
	&ccs_js_array;

 	print "  var v_email = new MakeArray($ArraySize);\n";
	print "  var areaOptions = new MakeArray($#mailing_lists)\n";

	for $i (0 .. $#mailing_lists) {
           $z = $i + 1;
	   print "  areaOptions[$z] = \"$mailing_lists[$i]\";\n"; 
	}

	for $i (0 .. $#list_entries ) {
		$list_entries[$i] =~ s/\n//g;
		print "  v_email[$i] = \"$list_entries[$i]\";\n";
	}
	
	print "</SCRIPT>\n\n";

	print "<BODY BGCOLOR=\"$pg_color\">\n";

	if ($use_image eq "Y") {
	   print "<CENTER><IMG SRC=\"$hdr_image\" ALT=\"Header\"></CENTER>\n";
	   print "\n";
	}

	print "<FORM METHOD=\"GET\" NAME=\"msg_form\">\n";
	print "<P><CENTER>\n";
	print "<TABLE BORDER=\"2\" BGCOLOR=\"$win_color\" CELLSPACING=\"2\" CELLPADDING=\"0\">\n";
	print "        <TR BORDER=\"0\" BGCOLOR=\"$title_color\">\n";

	print "         <TD VALIGN=\"CENTER\" BORDER=\"0\" HEIGHT=\"24\">\n";
	print "          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
	print "          <FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\">Mailing List Management</FONT>\n";
	print "          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";

	   print "              <SELECT NAME=\"mailing_list\" onChange=\"jumpPage(this.form);\">\n";
	   print "                   <OPTION>Select ...\n";
	   for $x (0 .. $#mailing_lists) {
	      $opt = $mailing_lists[$x];
	      if ($opt eq $mail_list) {
	         print "                   <OPTION SELECTED>$opt\n";
	      }

	      if ($opt ne $mail_list) {
	         print "                   <OPTION>$opt\n";
	      }

	   }
	   print "              </SELECT></TD>\n";
	print "         <TR BORDER=\"0\" BGCOLOR=\"$win_color\">\n";
	print "           <TD BORDER=\"0\" HEIGHT=\"76\">\n";
	print "                    <SELECT NAME=\"Entries\" MULTIPLE SIZE=\"10\" onChange=\"ShowText(this)\;\">\n";

	# Put Option List Together 
	for $i (0 .. $#list_entries ) {
		$option=$list_entries[$i];
		print "                     <OPTION VALUE=\"$option\">$option\n";
	}

	print "                    </SELECT>\n";
	print "<INPUT TYPE=\"button\" VALUE=\"Delete this Entry\" onClick=\"DelEntry(this.form);\">\n";
	print "</TABLE>\n";
	print "</CENTER></FORM>\n";
	print "</BODY>\n";
	print "</HTML>\n";

        exit 0;

        exit 0;


}


sub del_mail {

  $list = "$data_dir/maillists/$mail_list.mail";
  $temp = "$data_dir/maillists/$mail_list.temp";

  open(LST,"$list");
   @entries = <LST>;
  close(LST);

  ### Delete them from the  Mailing List if they exist ###
  open (NEW, "> $temp");
     for $i (0 .. $#entries ) {
	$entries[$i] =~ s/\n//g;
        if($entries[$i] ne $u_email) {
          print NEW "$entries[$i]\n";
        } 
     }
  close (NEW);

  ### Backup the original and rename the temp file
  rename $list, $list.".bak";
  rename $temp, $list;


  ### Change Permissions on both Files...
   if ($winows ne "Y" && $winodws ne "y") {
     `chmod 666 $list`;	
   }

   ### Let them know the operation was a success.
   $ok_message = "Entry was deleted from the list<P>";
   $ok_message .= "Name: $u_email    List: $mail_list<P>";
   $click = "self.location.href='mailman.cgi?action=edit_mail&mailing_list=$mail_list'";

   &ok_box($ok_message,$click);

   exit 0;

}

###########################################################################
#                 ___         __              _
#                /   |   ____/ / ____ ___    (_) ____
#               / /| |  / __  / / __ `__ \  / / / __ \
#              / ___ | / /_/ / / / / / / / / / / / / / _   _   _
#             /_/  |_| \__,_/ /_/ /_/ /_/ /_/ /_/ /_/ (_) (_) (_)
#
###########################################################################



###########################################################################
###########################################################################
sub admin_mail {


   if ($password ne $admin_pw) {
	&ccs_login("mailman.cgi");
   }

   else {
   ### Password Must be OK, Open Frames...

	print "Content-type: text/html\n\n";
	print "<HTML>\n";
	print "<HEAD>\n";
  	print "<TITLE>Mail Man Administration</TITLE>\n";
	print "</HEAD>\n";
	print "<frameset cols=\"20%,*\" framespacing=0 frameborder=0 border=0>\n";
    	print "<!-- Left Frame:  Shows Admin Buttons and available forums -->\n";
    	print "<frame name=\"menu\" src=\"mailman.cgi?action=menu&password=$admin_pw\" ";
	print "border=\"0\" scrolling=\"no\" frameborder=\"0\" framespacing=\"0\" ";
	print "marginwidth=\"0\" marginheight=\"0\" noresize>\n";
	print "<!-- Main Frame, Where you do work...     -->\n";
    	print "<frame name=\"work\" src=\"$html_dir/readme.htm\" border=\"0\" ";
	print "scrolling=\"yes\" frameborder=\"0\" framespacing=\"0\" ";
	print "marginwidth=\"0\" marginheight=\"0\" noresize>\n";
	print "</frameset>\n";
	print "</HTML>\n";


	exit 0;

   }

}


###########################################################################
###########################################################################
## Menu Frame...

sub nav_bar {

   if ($password ne $admin_pw) {
	&admin_login;
   }

	print "Content-type: text/html\n\n";
	print "<HTML>\n";
	print "<HEAD>\n";
  	print "<TITLE>JavaScript Mail Man Administration</TITLE>\n";
	print "</HEAD>\n";
	print "<SCRIPT LANGUAGE=\"javascript\">\n";

	print 'function EditList(FormAction) {';
	print "\n";
	print "      var Loc = FormAction + \"?action=edit_mail&password=$password\";\n";
	print '      parent.work.location.href = Loc;';
	print "\n";
	print '}';
	print "\n\n";

	print 'function AddList(FormAction) {';
	print "\n";
	print "      var Loc = FormAction + \"?action=new_mail&password=$password\";\n";
	print '      WAdd=open(Loc,"Add","toolbar=no,scrollbars=no,directories=no,menubar=no,resizable=yes,width=420,height=350")';
	print "\n";
	print '}';
	print "\n\n";

  	print 'function ShowHelp() {';
	print "\n";
    	print "   parent.work.document.location.href=\"$manual\";\n";
	print "\n";
	print "}\n";

	print 'function NewList(FormAction) {';
	print "\n";
	print "      var Loc = FormAction + \"?action=new_list&password=$password\";\n";
	print '      parent.work.location.href = Loc;';
	print "\n";
	print '}';
	print "\n\n";

	print 'function DelList(FormAction) {';
	print "\n";
	print "      var Loc = FormAction + \"?action=del_list&password=$password\";\n";
	print '      parent.work.location.href = Loc;';
	print "\n";
	print '}';
	print "\n\n";

	print 'function MailList(FormAction) {';
	print "\n";
	print "      var Loc = FormAction + \"?action=create_mail&password=$password\";\n";
	print '      parent.work.location.href = Loc;';
	print "\n";
	print '}';
	print "\n\n";

	print 'function MakeTemplate(FormAction) {';
	print "\n";
	print "      var Loc = FormAction + \"?action=create_text&password=$password\";\n";
	print '      parent.work.location.href = Loc;';
	print "\n";
	print '}';
	print "\n\n";

	print "</SCRIPT>\n\n";

	print "<BODY BGCOLOR=\"$pg_color\">\n";
	print "<CENTER>\n";
	print "<P><FONT COLOR=\"$text_color\"><H1>MailMan Admin</H1></FONT><P><P>\n";
	print "<FORM ACTION=\"mailman.cgi\" TARGET=\"work\" METHOD=\"POST\">\n";

	print "<INPUT TYPE=\"button\" NAME=\"send\" onClick=\"MailList('mailman.cgi');\" VALUE=\"Send Mail to List\"><P>\n";
	print "<INPUT TYPE=\"button\" NAME=\"list\" onClick=\"EditList('mailman.cgi');\" VALUE=\"Edit Mail Lists\"><P>\n";
	print "<INPUT TYPE=\"button\" NAME=\"list\" onClick=\"AddList('mailman.cgi');\" VALUE=\"Add to Mail Lists\"><P>\n";
	print "<INPUT TYPE=\"button\" NAME=\"list\" onClick=\"NewList('mailman.cgi');\" VALUE=\"New Mailing List\"><P>\n";
	print "<INPUT TYPE=\"button\" NAME=\"list\" onClick=\"DelList('mailman.cgi');\" VALUE=\"Delete Mailing List\"><P>\n";
	print "<INPUT TYPE=\"button\" NAME=\"hlp\" onClick=\"ShowHelp();\" VALUE=\"HELP\"><BR>\n";
	print "</FORM>\n";
	print "<CENTER>\n";
	print "</BODY>\n";
	print "</HTML>\n";

	exit 0;
}
