#!/usr/local/bin/perl
##############################################################################
# Hyperseek Search Engine                                                    #
# Copyright 2000 John Cokos     jcokos@ccs.net                               #
# Created 05/01/2000            Last Modified 05/16/2000                     #
# Script Home Page:            http://www.interactive-web.net                #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# The Hyperseek Search Engine, including all files in the this distribution  #
# may be modified only by registered users so long as...                     #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
#  _                           _   _                                         #
# | \ _  ._  __|_ |\/| _  _|o_|_  |_) _ | _      _|_|_ o _ ._  _ o.__|_ |    #
# |_/(_) | |(_)|_ |  |(_)(_|| |\/ |_)(/_|(_)\/\/  |_| ||_> |_)(_)|| ||_ o    #
#                              /                           |                 #
# __________________________________________________________________________ #


require ("iweb.pm");
require ("hyperseek.pm");

&parse_form;

$PROGRAM="Hyperseek Search Engine Top 10 List";
$VERSION="6.01";

$powered_by = "pb_hyperseek.jpg";

$CAT = $input{'Category'};

$delimiter = '|';

&Page_Header("top10");

exit 0;



sub Body {

   $raw_stats={};
   $count = 0;

    open(SITES,"$data_dir/hyperseek.dat");
      @sites=<SITES>;
    close(SITES);

    @Terms = split(/\|/,$CAT);
    $CAT =~ s/ /+/g;

    $ThisCategory = $Terms[0];
    $ThisSubCategory = $Terms[1];
  
    $DESC="$ThisCategory :: $ThisSubCategory";

    for $x( 0 .. $#sites ) {
       	($ID,$Category,$SubCategory,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$sites[$x]);

        if ($ThisCategory eq $Category && $ThisSubCategory eq $SubCategory) {

              open(DAT, "$data_dir/hits/$ID.cnt");
                @contents = <DAT>;
              close(DAT);

              ### Split the entities
              @temp = split(/\|/,$contents[0]);
             
              @{$raw_stats[$count++]}{qw( siteid title description clicks votes source)}=
                 ($ID, $Title, $Description, $temp[0], $temp[1], $temp[2]);

        }

    }

    @stats = sort { $b->{'votes'} <=> $a->{'votes'} } @raw_stats; 

    print "<CENTER><H5>$MESSAGE</H5></CENTER>\n";
    print "<CENTER><H4>Top 10 Listings ... <A HREF=\"$CGI_DIR/hyperseek.cgi?search=CAT&Category=$CAT\">$DESC</A> </H4>\n";
    print "<CENTER><TABLE WIDTH=670 BORDER=2 CELLSPACING=0 CELLPADDING=8>\n";
    print "<TR BGCOLOR=\"$title_color\">\n";
    print "<TD WIDTH=75><CENTER><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\" SIZE=+1><U>RANK</TD>\n";
    print "<TD WIDTH=475><CENTER><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\" SIZE=+1><U>SITE</TD>\n";
    print "<TD WIDTH=40><CENTER><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\" SIZE=+1><U>Votes</TD></TR>\n";

    for $z ( 0 .. 10 ) {
       
           $rank = $z + 1;
           $rank_image = "";
           @digit = split(//, $rank);
           foreach $digit (@digit) {
             $rank_image .= "<img src=\"$button_dir/$digit.gif\">";
           }

           $Description =~ s/<CR>/<BR>/g;

           if ($stats[$z]{'siteid'} && $stats[$z]{'votes'} > 0) {
              print "<TR BGCOLOR=\"$win_color\">\n";
              print "<TD WIDTH=75><CENTER>$rank_image</CENTER></TD>\n";
              print "<TD WIDTH=475><FONT COLOR=\"$text_color\" FACE=\"$font_face\"><A HREF=\"$CGI_DIR/go.cgi?ID=$stats[$z]{'siteid'}\">$stats[$z]{'title'}</A><BR><BLOCKQUOTE>$stats[$z]{'description'}</BLOCKQUOTE></A></TD>\n";
              print "<TD WIDTH=40><FONT COLOR=\"$text_color\" FACE=\"$font_face\">$stats[$z]{'votes'}</TD></TR>\n";
           }
    }

    print "</TABLE>\n";
    

}
